// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#ifndef APPLICATION_H
#define APPLICATION_H

#include <qmainwindow.h>
#include <qwidgetlist.h>
#include "xbsch.h"

//class QMultiLineEdit;
class QToolBar;
class QLabel;
class QPopupMenu;
class QToolButton;
class QScrollView;
class SXBSchView;

class ApplicationWindow: public QMainWindow
{
	Q_OBJECT
public:
    ApplicationWindow();
	~ApplicationWindow();
	QString fileName();
	bool isEmptyDocWindow();
	static  ApplicationWindow* firstEmptyDocWindow();
protected:
    void closeEvent( QCloseEvent* );
	void keyPressEvent ( QKeyEvent * e );
	void ZoomIn(bool menucommand);
	void ZoomOut(bool menucommand);

public slots:
void load(const QString &fn);

private slots:
	//MENU
	//FILE
	void newDoc();
    void load();
    int save();
    int saveAs();
    void print();
	void exportImage();
	//EDIT
	void EditUndo();
	void EditCut();
	void EditCopy();
	void EditPaste();
	void EditDelete();
	void EditAttr();
	void EditMirror();
	void EditRotate();
	void EditInvert();	
	//VIEW
	void ViewRefresh();
	void ViewZoomIn();
	void ViewZoomOut();
	void ViewGridOnOff();
	//TOOL
	void ToolSelector();
	void ToolDrag();
	void ToolComp();
	void ToolBus();
	void ToolWire();
	void ToolDash();
	void ToolJunction();
	void ToolBEntry();
	void ToolEntry();
	void ToolTag();
	void ToolLabel();
	void ToolCmnt();
	//SET
	void SetSheetSize();
	void SetSnap();
	void SetLibrary();
	void SetFont();
	//HELP
    void about();
    void aboutQt();

	//ӥ塼ǤΥ֤ΰư
	void cursorMove(int x,int y);
	void toolChange();
	
	//Window˥塼Υߥ󥰤
	void setupWindowMenu();
	
	//Window˥塼Υƥब򤵤줿ȤSLOT
	void selectActiveDocument(int id);

private:
	static QWidgetList m_appWindowList;

    //QPrinter* printer;
    //QMultiLineEdit *e;
    //QToolBar *fileTools;
    QToolBar* toolbar;
    QString m_filename;
	QLabel* m_plabelX;
	QLabel* m_plabelY;
	
	QPopupMenu *m_menuWindow;

	QToolButton* m_ptbFileOpen;
	QToolButton* m_ptbFileSave;
    QToolButton* m_ptbFilePrint;
    QToolButton* m_ptbToolSelect;
    QToolButton* m_ptbToolDrag;
    QToolButton* m_ptbToolComp;
    QToolButton* m_ptbToolBus;
    QToolButton* m_ptbToolWire;
    QToolButton* m_ptbToolDash;
    QToolButton* m_ptbToolJunc;
    QToolButton* m_ptbToolBEnt;
    QToolButton* m_ptbToolEnt;
    QToolButton* m_ptbToolTag;
    QToolButton* m_ptbToolLabel;
    QToolButton* m_ptbToolCmnt;

	int m_nMenuIdEditUndo;
	int m_nMenuIdEditCut;
	int m_nMenuIdEditCopy;
	int m_nMenuIdEditPaste;
	int m_nMenuIdEditDelete;
	int m_nMenuIdEditAttr;
	int m_nMenuIdEditMirror;
	int m_nMenuIdEditRotate;
	int m_nMenuIdEditInvert;

	int m_nMenuIdViewZoomIn;
	int m_nMenuIdViewZoomOut;
	int m_nMenuIdViewGrid;

	int m_nMenuIdToolSelect;
	int m_nMenuIdToolDrag;
	int m_nMenuIdToolComp;
	int m_nMenuIdToolBus;
	int m_nMenuIdToolWire;
	int m_nMenuIdToolDash;
	int m_nMenuIdToolJunc;
	int m_nMenuIdToolBEnt;
	int m_nMenuIdToolEnt;
	int m_nMenuIdToolTag;
	int m_nMenuIdToolLabel;
	int m_nMenuIdToolCmnt;

	int m_nMenuIdSetSnap;


private:
	//BSCH_TOOL_MODE m_toolmode;
	void SetToolButtonState();	//ġܥξ֤ꤹ

//	QScrollView* m_pScrollView;
	SXBSchView* m_pXBSchView;
	
	void setAppCaption();		//ץꥱΥץ

};


#endif
