// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <list>
using namespace std;
#include "ce3io.h"
//#include "csvio.h"
#include "cfgdata.h"


//#define CSVBUFFLEN 1024

SCfgData::SCfgData()
{
	//listCfgData.setAutoDelete(true);
}

SCfgData::~SCfgData()
{
	clear();
}

void SCfgData::clear()
{
	SCfgListIte ite = listCfgData.begin();
	while(ite != listCfgData.end()){
		SCfgDataElm* elm = *ite++;
		delete elm;
	}
	listCfgData.clear();
}

//¸Υ롼פȥ򸡺
SCfgDataElm* SCfgData::findExisting(const string& sGroup,const string& sKey)
//SCfgDataElm* SCfgData::findExisting(const char* pszgroup,const char* pszkey)
{
	SCfgListIte ite = listCfgData.begin();
	//¸Υ롼פȥΥå
	while(ite != listCfgData.end()){
		SCfgDataElm* elm = *ite++;
		if(elm->group == sGroup && elm->key == sKey) return elm;
	}
	return NULL;
}


//ǡΥ
bool SCfgData::load(const char* filename)
{
	string str;
	string strGroup;
	string strKey;
	string strData;

	FILE* fp = fopen(filename,"r");
	if(fp==NULL) return false;
	SReadCE3 rce3;
	rce3.Attach(fp);

	while(rce3.ReadRecord(str)!=EOF){
		if(str[0]!='+') break;
		strGroup = str.substr(1);
		while(rce3.ReadRecord(str)!=EOF){
			if(str[0]=='-') break;
			int n;
			int l=str.length();
			for(n=0;n<l;n++){
				if(str[n]==':') break;
			}
			if(0<n && n<(l-1)){	// : ʬ줿쥳ɤǤ
				strKey = str.substr(0,n);	//Ƭ:μޤ
				strData =str.substr(n+1);	//:齪üޤ

				SCfgDataElm* elm = new SCfgDataElm;
				elm->group	= strGroup;
				elm->key	= strKey;
				elm->data	= strData;
				//ꥹȤؤappend
				listCfgData.push_back(elm);
			}
		}
	}
	fclose(fp);
	return true;

}

//ǡΥեؤ¸
bool SCfgData::save(const char* filename)
{

	FILE* fp = fopen(filename,"w");
	if(fp==NULL) return false;

	SWriteCE3 wce3;
	wce3.Attach(fp);
	while(1){
		SCfgDataElm* elm = NULL;
		SCfgListIte ite = listCfgData.begin();
		while(ite != listCfgData.end()){
			elm = *ite++;
			//¸ѤߤΤΤ group""ˤʤäƤ롣
			if(elm->group!="" && elm->key!="" && elm->data!="") break;
			elm = NULL;
		}

		if(elm != NULL){
			string strTag = "+";
			string strGroup = elm->group;
			strTag += strGroup;
			if(wce3.WriteRecord(strTag)) return false;
			if(wce3.WriteEOL()) return false;
			while(elm != NULL){
				if(strGroup == elm->group){
					string strRecord;
					elm->group = "";
					strRecord = elm->key;
					strRecord += ":";
					strRecord += elm->data;
					if(wce3.WriteRecord(strRecord)) return false;
					if(wce3.WriteEOL()) return false;
				}
				if(ite != listCfgData.end()){
					elm = *ite++;
				}else{
					elm = NULL;
				}
			}
			strTag[0]='-';
			if(wce3.WriteRecord(strTag)) return false;
			if(wce3.WriteEOL()) return false;
		}else{
			break;
		}
	}
	fclose(fp);
	clear();				//ä󥯥ꥢ
	return load(filename);	//ɤ߹
}

//groupkeyꤷơʸdataꤹ
void SCfgData::setString(const string& sGroup,const string& sKey,const string& sData)
{

	if( sGroup=="" || sKey=="") return;
	//¸Υ롼פȥΥå
	SCfgDataElm* elm = findExisting(sGroup,sKey);
	if(!elm){	//¸Υ롼פȥĤʤä
		//elmοȡgroup key data γǼ
		elm = new SCfgDataElm;
		elm->group 	= sGroup;
		elm->key 	= sKey;
		elm->data 	= sData;
		listCfgData.push_back(elm);
	}else{
		elm->data = sData;
	}		
}

//groupkeyꤷơdataꤹ
//ͤʸѴƤsetStringƤǤ
void SCfgData::setInt(const string& sGroup,const string& sKey,int data)
{
	char szData[64];
	sprintf(szData,"%d",data);
	setString(sGroup,sKey,szData);
}

bool SCfgData::getString(const string& sGroup,const string& sKey,string& sData)
{
	if( sGroup=="" || sKey=="" ) return false;

	//¸Υ롼פȥΥå
	SCfgDataElm* elm = findExisting(sGroup,sKey);
	if(!elm){	//¸Υ롼פȥĤʤä
		sData="";
	}else{
		sData = elm->data;
	}
	return sData!="";
}

bool SCfgData::getInt(const string& sGroup,const string& sKey,int& data)
{
	if( sGroup=="" || sKey=="" ) return false;

	//¸Υ롼פȥΥå
	SCfgDataElm* elm = findExisting(sGroup,sKey);
	if(!elm){	//¸Υ롼פȥĤʤä
		data=0;
		return false;
	}else{
		data=atoi(elm->data.c_str());
		return true;
	}
}
/*
//
void SCfgData::dump()
{
	SCfgListIte ite = listCfgData.begin();
	//¸Υ롼פȥΥå
	while(ite != listCfgData.end()){
	printf("START SCfgData::dump()**************\n");
	while(elm){
		SCfgDataElm* elm = *ite++;
		printf("%s,%s,%s\n",elm->group.c_str(),elm->key.c_str(),elm->data.c_str() );
	}
	printf("****************SCfgData::dump() END\n");
	return;
}
*/
