// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#ifndef COMPLIB_H
#define COMPLIB_H


class SReadCE3;
class SWriteCE3;


////////////////////////////////////////////////////////////////////
//ʥ饤֥˴ط


enum PIN_TYPE
{
	PIN_TYPE_NOMAL		=0x00,
	PIN_TYPE_SMALL		=0x01,
	PIN_TYPE_CLOCK		=0x04,
	PIN_TYPE_NEGATIVE	=0x08,
	PIN_TYPE_NUMHIDE	=0x10
};

enum PIN_LOC
{
	PIN_LOC_L			=0x0,
	PIN_LOC_T			=0x1,
	PIN_LOC_R			=0x2,
	PIN_LOC_B			=0x3
};




//LB3饤֥ɤ߹ߤǻȤѥ󥯥饹
class SPtn
{
protected:
	unsigned char* readBmp(SReadCE3& rce3);//,int x,int y,int nBuffSize);

public:
	char*			m_pszName;		//ѥ̾
	SSize			m_size;			//
	int				m_nBuffsize;	//ХåեΥ
	unsigned char*	m_pBuff;		//ХåեؤΥݥ

	SPtn(){							//󥹥ȥ饯
		m_pszName=NULL;
		m_nBuffsize=0;
		m_pBuff=NULL;
		m_size=SSize(0,0);
	}

	SPtn(const SPtn&);				//ԡ󥹥ȥ饯
	SPtn& operator=(const SPtn&);	//黻	

	virtual ~SPtn(){				//ǥȥ饯
		delete[]m_pszName;
		delete[]m_pBuff;
	}
	bool readCe3(SReadCE3& rce3);
	bool writeCe3(SWriteCE3& wce3,const char* pszName);
	void setSize(const SSize& sizePixel);
};



////////////////////////////////////////////////////////////////////
//ԥ󥯥饹
class SPin
{
protected:
	int			m_nBlock;	//m_nBlockοԥֹʸƤ
	char**		m_ppszNum;	//ԥֹʸؤΥݥ
	char*		m_pszName;	//ԥ̾ؤΥݥ
	int			m_nType;	//ԥΥ
	int			m_nLTRB;	// LTRB
	int			m_nOffset;	// եå
protected:
	void deleteBuff();

public:
	SPin();					//󥹥ȥ饯
	~SPin();
	SPin(const SPin&);				//ԡ󥹥ȥ饯
	SPin& operator=(const SPin&);	//黻

	
	void setBlock(int  nBlock);	//֥å򥻥åȤ롣
	void setPinName(const char* name);				//ԥ̾򥻥åȤ롣
	void setPinNum(int nBlock,const char* name);	//ԥֹ򥻥åȤ롣
	void setType(int type){ m_nType=type;}
	void setLtrb(int ltrb){ m_nLTRB=ltrb;}
	void setOffset(int offset){m_nOffset=offset;}
	const char* pinName() const {return m_pszName;}
	const char* pinNum(int nBlock) const;
	int type() const {return m_nType;}
	int ltrb() const {return m_nLTRB;}
	int offset() const {return m_nOffset;}
	int block() const { return m_nBlock;}

	bool readCe3(SReadCE3& rce3,int block);
	bool writeCe3(SWriteCE3& rce3);
};

typedef SPin* PSPin;
////////////////////////////////////////////////////////////////////
//ʾ󥯥饹
class SCompInfo
{
protected:
	void deleteBuff();

public:
	char*	m_pszRef;	//ǥեֹ
	SSize	m_size;		//ʤΥ
	int		m_nBlock;	//ѥåΥ֥å
	SPtn*	m_pPtn;		//LB3ɤ߹ѥؤΥݥ
	int		m_nPinCount;//ԥ
	PSPin*	m_ppPin;	//LB3ɤ߹ԥ󥯥饹ؤΥݥ
	SCompInfo(){		//󥹥ȥ饯
		m_pszRef	=NULL;
		m_nBlock	=1;
		m_pPtn		=NULL;
		m_nPinCount	=0;
		m_ppPin		=NULL;
	}
	~SCompInfo();			//ǥȥ饯

	SCompInfo(const SCompInfo&);			//ԡ󥹥ȥ饯
	SCompInfo& operator=(const SCompInfo&);	//黻

	bool readCe3(SReadCE3& rce3,string& name,string& ptnname);	//ե뤫ɤ߹
	bool writeCe3(SWriteCE3& wce3,const char* pszName);

	void setRef(const char* ref);		//ǥեֹ
	void setSize(const SSize& size,bool createPtn);	// ѥͭϥѥΥѹ
	void setUsePattern(bool usepattern);
	void setBlock(int block);
	void addPin(SPin* ppin);
	void removePin(int ltrb,int offset,bool move);
	void insertNullPin(int ltrb,int offset);
	SPin* pinInfo(int ltrb,int offset);	//ꤷ֤Υԥ
};

////////////////////////////////////////////////////////////////////
//ʥǥå饹
class SCompIndex
{
	char*				m_lpszName;	//̾
public:
	SCompInfo*			m_pCompInfo;//бʾ󥯥饹ؤΥݥ

	SCompIndex(){			//󥹥ȥ饯
		m_lpszName	=NULL;
	}
	~SCompIndex(){			//ǥȥ饯
		delete[]m_lpszName;
	}
	void setName(const char* name);
	void setCompInfo(SCompInfo* pcinfo){m_pCompInfo = pcinfo;}

	SCompInfo* compInfo() const{return m_pCompInfo;}
	const char*	name() const{return m_lpszName;}			//̾
	const char* number() const;			//ֹ
	SSize size() const;					//
	SSize sizePlace(int dir) const;		//ֻο̾Υ
	int	  block() const;				//ѥåΥ֥å
	SPtn*	pattern() const;			//ѥؤΥݥ󥿤
	int	pinCount() const;				//ԥο
	SPin* pin(int index) const;			//ԥξ
	//ԥξ
	//ξ󤫤顢ԥΰ־(LTRBȡΥեå)֤
	SPin* SCompIndex::pin(int index,int dir,int& nLtrb,SPoint& ptEnd) const;

};



typedef SCompIndex* PSCompIndex;

typedef list<SPtn*> SPtnList;
typedef list<SPtn*>::iterator SPtnListIterator;

typedef list<SCompInfo*> SCompInfoList;
typedef list<SCompInfo*>::iterator SCompInfoListIterator;

typedef list<SCompIndex*> SCompIndexList;
typedef list<SCompIndex*>::iterator SCompIndexListIterator;


////////////////////////////////////////////////////////////////////
//ʥ饤֥ꥯ饹
class SCompLib
{
public:
	char*			m_lpszLibraryName;		//饤֥̾
	SPtnList		m_listPtn;				//ɤ߹ѥΥꥹ
	SCompInfoList	m_listCompInfo;			//ɤ߹߹ʥ饹Υꥹ
	SCompIndexList	m_listCompIndex;		//ɤ߹߹ʥǥåΥꥹ
	PSCompIndex*	m_ppCompIndex;			//ɤ߹߹ʥǥåΥݥ
	//int				m_nCount;

public:
	SCompLib(){										//󥹥ȥ饯
		m_lpszLibraryName=NULL;
		m_ppCompIndex=NULL;
		//m_nCount=0;
	}
	~SCompLib();										//ǥȥ饯
	bool ReadLb3(SReadCE3& rce3);//LB3饤֥ɤ߹
	bool readLibraryFile(const char* lpszFileName);		//եɤ߹
	const char* libraryName() const ;					//饤֥̾
	int count() const{return m_listCompIndex.size();}	//ʿ
	SCompIndex* compIndex(int nIndexNum) const;			//nܤʤΥǥå

	static bool WriteAlias(SWriteCE3& wce3,const char*  alias,const char*  name);
	string uniqueName(const string& name);	//¸̾ȽŤʤʤ̾

private:
	bool ReadLb3Ptn(SReadCE3& rce3);//ѥɤ߹
	bool ReadLb3Comp(SReadCE3& rce3);
	bool ReadLb3Alias(SReadCE3& rce3);



	bool isUniqueName(const string& name);	//¸̾ȽʣƤʤɤ

	//bool WriteLb3Pin(SWriteCE3& wce3,const SPin& pin);							//ԥν񤭹
	//bool WriteLb3Ptn(SWriteCE3& wce3,const SPtn& ptn,const char*  name);			//ѥν񤭹
	//bool WriteLb3Comp(SWriteCE3& wce3,const SCompInfo& compinfo,SWriteCE3& wce3);	//ʤν񤭹
	
};


#endif