// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#include <qlineedit.h>
#include <qfont.h>
#include <qfontdialog.h>

#include "editcommentimpl.h"

/* 
 *  Constructs a editcomment which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
editcomment::editcomment( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : editcommentBase( parent, name, modal, fl )
{
}

/*  
 *  Destroys the object and frees any allocated resources
 */
editcomment::~editcomment()
{
    // no need to delete child widgets, Qt does it all for us
}

int editcomment::exec()
{
	LineEdit->setText(m_text);
	LineEdit->setFocus();
	return editcommentBase::exec();
}

void editcomment::fontbuttonClicked()
{
	//qDebug("editcomment::fontbuttonClicked()");
	bool ok;
	QFont font=QFontDialog::getFont(&ok,m_font,this);
	if(ok){m_font=font;}
}


void editcomment::accept()
{
	m_text = LineEdit->text();
	editcommentBase::accept();
}


void editcomment::setText(const QString& text)
{
	m_text = text;
}

QString editcomment::text()
{
	return m_text;
}

