// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#include <qlineedit.h>

#include "editlabelimpl.h"

/* 
 *  Constructs a EditLabel which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
EditLabel::EditLabel( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : EditLabelBase( parent, name, modal, fl )
{
}

/*  
 *  Destroys the object and frees any allocated resources
 */
EditLabel::~EditLabel()
{
    // no need to delete child widgets, Qt does it all for us
}

int EditLabel::exec()
{
	editLabel->setText(m_strLabel);
	editLabel->setFocus();
	return EditLabelBase::exec();
}

void EditLabel::accept()
{
	//qDebug("EditLabel::accept\n");
	m_strLabel = editLabel->text();
	EditLabelBase::accept();
}

void EditLabel::setText(const QString & text)
{
	m_strLabel=text;
}

QString EditLabel::text ()
{
	return m_strLabel;
}
