// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
//XBSchΥɥȤδԤ

//#include <qapplication.h>
//#include <qwidget.h>
//#include <SSize.h>
//#include <SPoint.h>
//#include <qclipboard.h>
#include <stdio.h>
#include <assert.h>
#include <string>
#include <list>
using namespace std;
#include "ce3io.h"
#include "xbschobj.h"
#include "xbschjunc.h"
#include "xbschlabel.h"
#include "xbschcomment.h"
#include "xbschtag.h"
#include "xbschcomponent.h"

#include "xbschline.h"
#include "xbschentry.h"
#include "xbschdelobj.h"
#include "xbschsheetinfo.h"
#include "xbschdoc.h"




SXBSchDoc::SXBSchDoc()
{
	m_bDirty = false;
	m_sizeSheet = SSize(1500,1000);
//	m_pView = NULL;
	m_bSelectForDrag = false;
	init();
}

SXBSchDoc::~SXBSchDoc()
{
	init();
}

bool SXBSchDoc::isEmpty()
{
	if( (m_listMain.size() > 0) || (m_listTemp.size() > 0 )) return false;
	else return true;
}


//ȥ
void SXBSchDoc::SetSheetSize(const SSize& size)
{
	if(size.w()<500||size.w()>3000||size.h()<400||size.h()>2000)return;
	m_sizeSheet = size;
}

//Ǥɲ ֹ֤
int SXBSchDoc::add(SXBSchObj* pObj)
{
	if(pObj == NULL) return m_nOpCount;
	m_nOpCount++;
	m_bDirty = true;	
	pObj->setPlaceNum(m_nOpCount);	
	m_listMain.push_back(pObj);
	return m_nOpCount;
}

//֤ɲÿǤɲ ֹ֤
int  SXBSchDoc::addSelect(SXBSchObj* pObj)
{
	m_listTemp.push_back(pObj);
	setupRcTempArea();
	m_bDirty = true;	
	return m_nOpCount;
}

//ꤷƤ
//ꤷƤǤϡ1ĤΥ֥ȤФʤ
int SXBSchDoc::select(const SPoint& pt)
{
	resetSelect();
	SXBSchObj* pObjSelected = NULL;
	int maxSelectWeight=0;
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte !=  m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		  &&(*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			int SelectWeight = (*pObjIte)->qSelectWeight(pt) & 0xFFFF;
			if(SelectWeight > maxSelectWeight){
				maxSelectWeight = SelectWeight;
				pObjSelected = (*pObjIte);
			}
		}
		pObjIte++;
	}
	if(pObjSelected != NULL){
		SXBSchObj* pNewObj = pObjSelected->duplicate();
		pObjSelected->setRefObj(pNewObj);
		pNewObj->setRefObj(pObjSelected);
		pNewObj->setSelection(SXBSchObj::SELECT_ALL);
		m_listTemp.push_back(pNewObj);
	}
	setupRcTempArea();
	setupRotateRect();
	m_bSelectForDrag = false;
	return m_listTemp.size();
}

//ϰϤꤷƤ
//Ȥϡ
//  ᥤΥꥹȤ鳺Τ򸫤Ĥ
//  ʣ֥Ȥɲä
//򤷤֤
int SXBSchDoc::select(const SRect& rc)
{
	resetSelect();
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte != m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		 && (*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			unsigned nSelStatus = (*pObjIte)->testSelection(rc);
			if(nSelStatus){
				SXBSchObj* pNewObj = (*pObjIte)->duplicate();
				(*pObjIte)->setRefObj(pNewObj);
				pNewObj->setRefObj(*pObjIte);
				pNewObj->setSelection(nSelStatus);
				m_listTemp.push_back(pNewObj);
			}
		}
		*pObjIte++;
	}
	setupRcTempArea();
	setupRotateRect();

	m_bSelectForDrag = false;
	return m_listTemp.size();
}



bool SXBSchDoc::resetSelect_1(bool bDel)
{
	//֥ȤΥꥹȤʤ鲿⤷ʤ
	if(m_listTemp.size() == 0) return false;

	m_nOpCount++;
	m_bDirty = true;	

	XBSchObjListIterator pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		if((*pObjIte)->refObj()){ //֥Ȥȥ֥Ȥľ硢ȥ֥ȤϸΥǡؤ
			SXBSchObj* pOldObj = (*pObjIte)->refObj();
			//֥Ȥɲ
			SXBSchDelObj* pDelObj = new SXBSchDelObj;
			//qDebug("Add DeleteObj");
			pDelObj->setPlaceNum(m_nOpCount);	
			pDelObj->setRefObj(pOldObj); //֥ȤrefObj()ˤоݥ֥ȤؤΥݥ󥿤򥻥åȤ
			pOldObj->setRefObj(pDelObj); //Υ֥ȤˤϺ֥ȤؤΥݥ󥿤򥻥åȤ
			m_listMain.push_back(pDelObj);
		}
		if(!bDel){
			//ǡᥤΥꥹȤɲ
			if((*pObjIte)->qValid()){
				(*pObjIte)->setPlaceNum(m_nOpCount);		//ֹ򹹿
				(*pObjIte)->setRefObj(NULL);				//ȥ֥Ȥ϶ˤͭǡˤʤ
				(*pObjIte)->resetSelection();				//ե饰򥯥ꥢ롣
				m_listMain.push_back(*pObjIte);
			}
		}else{
			//ǡõ
			delete (*pObjIte);
		}
		*pObjIte++;
	}
	m_listTemp.clear();
	m_bSelectForDrag = false;

	delOldData(m_nOpCount-10);		//Undo

	return true;
}

//m_rcTempArea  m_ptTempSnapPoint ֥ȤΥꥹȤꤹ롣
void SXBSchDoc::setupRcTempArea()
{
	if(m_listTemp.size() == 0)return;
	m_rcTempArea = SRect(SPoint(INT_MAX,INT_MAX),SPoint(INT_MIN,INT_MIN));

	XBSchObjListIterator pObjIte = m_listTemp.begin();
	bool bFind1st = true;
	while(pObjIte != m_listTemp.end()){
		m_rcTempArea |= (*pObjIte)->area();
		if(bFind1st){
			m_ptTempSnapPoint = (*pObjIte)->snapPoint();
			bFind1st = false;
		}
		pObjIte++;
	}
}

void SXBSchDoc::setupRotateRect()
{
	if(m_listTemp.size() == 0)return;
	m_rcRotateRect = SRect(SPoint(INT_MAX,INT_MAX),SPoint(INT_MIN,INT_MIN));

	XBSchObjListIterator pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		m_rcRotateRect |= (*pObjIte)->rotateRect();
		pObjIte++;
	}
	//qDebug("%d,%d\n",m_rcRotateRect.l(),m_rcRotateRect.r());
}



bool SXBSchDoc::writeMinimumLb3(SWriteCE3& wce3,XBSchObjList* pList,bool bOwnOnly)
{
//typedef list<SCompIndex*> SCompIndexList;
//typedef list<SCompIndex*>::iterator SCompIndexListIterator;

	return true;
}


bool SXBSchDoc::writeCe3(SWriteCE3& wce3,XBSchObjList* pList,bool bAllObj,const SPoint* pptOrigin)
{
	SRect rcSheet(0,0,m_sizeSheet.w(),m_sizeSheet.h());
	if(pList){
		XBSchObjListIterator pObjIte = pList->begin();
		while(pObjIte != pList->end()){
			if(bAllObj || !(*pObjIte)->refObj()){
				if(rcSheet.intersect((*pObjIte)->area())){
					(*pObjIte)->writeCe3(wce3,pptOrigin);
				}
			}
			pObjIte++;
		}
	}
	return true;
}


bool SXBSchDoc::readCe3(SReadCE3& rce3,XBSchObjList* pList,const SPoint* pptOrigin,SXBSchSheetInfo* pSheetInfo)
{

	assert(pList!=NULL);
	string str;
	bool bFirstSheetInfo = true;
	SXBSchObj* pObj;
	while(rce3.ReadRecord(str)!=EOF){
		if(str == "") break;		//Υ쥳ɤ̵뤹
		pObj = NULL;
		if(str == "+SHEETINFO" && bFirstSheetInfo && pSheetInfo){
			bFirstSheetInfo = false;
			if(! pSheetInfo->readCe3(rce3,pptOrigin,this)) return false;
		}else if(str == "+JUNCTION"){
				pObj = new SXBSchJunc;
		}else if(str == "+LABEL"){
				pObj = new SXBSchLabel;
		}else if(str == "+COMMENT"){
				pObj = new SXBSchComment;
		}else if(str == "+TAG"){
				pObj = new SXBSchTag;
		}else if(str == "+WIRE"){
				pObj = new SXBSchWire;
		}else if(str == "+BUS"){
				pObj = new SXBSchBus;
		}else if(str == "+DASH"){
				pObj = new SXBSchDash;
		}else if(str == "+ENTRY"){
				pObj = new SXBSchEntry;
		}else if(str == "+BENTRY"){
				pObj = new SXBSchBusEntry;
		}else if(str == "+COMPONENT"){
				pObj = new SXBSchComponent;
		}else if(str == "-BSCH3_DATA_V.1.0"){
			return true;
		}else{
			if(str[0] != '+') return false;
			str[0]='-';
			if(rce3.SkipTo(str)==EOF) return false;
			//if(rce3.SkipTo(str.replace(1,1,"-")) != SCsvIStream::GETRECORD_NORMAL)return false;
		}
		if(pObj){
			if(pObj->readCe3(rce3,pptOrigin,this)){
				if(pObj->qValid()){
					pList->push_back(pObj);
				}else{
					delete pObj;
				}
			}else{
				delete pObj;
				return false;
			}
		}
	}		
	return true;
}





//β
//βȤϡ
//  ǡؤΥ֥Ȥؤֺ֥ȡפᥤΥꥹȤɲä
//                      ǡᥤΥꥹȤɲä뤳
bool SXBSchDoc::resetSelect()
{
	return resetSelect_1(false);
}


//
void SXBSchDoc::init()
{
	m_bDirty = false;
	m_nOpCount = 0;
	m_nOldestOpCount = 0;
	m_visibleLayer =0xFF;
	m_editLayer = 0;
	

	XBSchObjListIterator pObjIte;

	pObjIte = m_listMain.begin();

	while(pObjIte != m_listMain.end()){
		delete (*pObjIte);
		pObjIte++;
	}
	m_listMain.clear();

 	pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		delete (*pObjIte);
		pObjIte++;
	}
	m_listTemp.clear();

//printf("\n");
//printf("SXBSchDoc::init() m_listMain.count()=%d,m_listTemp.count()=%d\n",m_listMain.count(),m_listTemp.count());
}

//ե뤫ɤ߹
//ｪλ0֤
//  1:եɤ߹ߥ顼
//  2:BSCH3եǤϤʤ
int SXBSchDoc::readFile(FILE* fp)
{
	if(fp ==NULL) return 1;
	SReadCE3 rce3;
	rce3.Attach(fp);

	string str;
	if(rce3.ReadRecord(str)==EOF){	//ΥեΤȤν
		fclose(fp);
		return 0;
	}
	SXBSchSheetInfo sheetInfo;
	if(str != "+BSCH3_DATA_V.1.0") return 2;
	if(readCe3(rce3,&m_listMain,NULL,&sheetInfo)){
		m_sizeSheet.setW(sheetInfo.width());
		m_sizeSheet.setH(sheetInfo.height());
		m_editLayer = sheetInfo.editLayer();
		m_visibleLayer = sheetInfo.visbleLayer();
		return 0;
	}else{
		fclose(fp);
		return 1;
	}
}


int SXBSchDoc::readFile(const char* fname)
{
	init();
	m_bDirty = false;
	FILE* fp;
	if((fp = fopen(fname,"r"))==NULL) return 1;
	int retval = readFile(fp);
	fclose(fp);
	return retval;
}


int SXBSchDoc::writeFile(FILE* fp)
{
	if(fp ==NULL) return 1;
	SWriteCE3 wce3;
	wce3.Attach(fp);
	SXBSchSheetInfo sheetInfo;
	sheetInfo.setWidth( m_sizeSheet.w() );
	sheetInfo.setHeight( m_sizeSheet.h() );
	sheetInfo.setEditLayer(m_editLayer);
	sheetInfo.setVisbleLayer(m_visibleLayer);

	wce3.WriteRecord("+BSCH3_DATA_V.1.0");
	wce3.WriteEOL();
	sheetInfo.writeCe3(wce3,NULL);
	writeCe3(wce3,&m_listMain,false,NULL);
	wce3.WriteRecord("-BSCH3_DATA_V.1.0");
	if(wce3.WriteEOL()==EOF){
		return 1;
	}else{		
		return 0;
	}
}

//եؤν񤭹
//ｪλ0֤
int SXBSchDoc::writeFile(const char* fname)
{
	resetSelect();
	FILE* fp;
	if((fp = fopen(fname,"w"))==NULL) return 1;
	int retval = writeFile(fp);
	fclose(fp);
	if(retval==0){
		init();
		readFile(fname);
		m_bDirty = false;
	}
	return retval;
}

/*
// ***** Qt¸ *****
//ԡ
//ԡԤ줿Ȥtrue֤
bool SXBSchDoc::copy()
{
	if(!m_listTemp.size())return false;
	SPoint ptOrigin = SPoint(m_rcTempArea.l(),m_rcTempArea.t());
	ptOrigin.setX(((ptOrigin.x()+5)/10)*10);
	ptOrigin.setY(((ptOrigin.y()+5)/10)*10);

	string str;
	SWriteCE3 wce3;
	wce3.Attach(&str);

	wce3.WriteRecord("+BSCH3_DATA_V.1.0");
	wce3.WriteEOL();
	writeCe3(wce3,&m_listTemp,true,&ptOrigin);
	wce3.WriteRecord("-BSCH3_DATA_V.1.0");
	wce3.WriteEOL();

    QClipboard *cb = QApplication::clipboard();
    cb->setText(QString::fromLocal8Bit(str.c_str()));
	
	return true;
}
*/

//
//ɥȤѹäȤtrue֤
bool SXBSchDoc::del()
{
	m_bDirty = true;	
	return resetSelect_1(true);
}

//ڤ
//ɥȤѹäȤtrue֤
bool SXBSchDoc::cut()
{
	if(copy()){
		return del();
	}
	return false;
}

/*
// ***** Qt¸ *****
//Žդ
//ɥȤѹäȤtrue֤
bool SXBSchDoc::paste(const SPoint& pt)
{
	if(!canPaste()) return false;
    QClipboard *cb = QApplication::clipboard();
	string cbbuff=string(cb->text().local8Bit());

	SReadCE3 rce3;
	rce3.Attach(cbbuff.c_str());

	string str;

	rce3.ReadRecord(str);
	if(str != "+BSCH3_DATA_V.1.0") return false;

	readCe3(rce3,&m_listTemp,&pt,NULL);
	if(!m_listTemp.size()) return false;
	
	setupRcTempArea();

	m_bDirty = true;	
	return true;
}
*/


//Undo
//ɥȤѹäȤtrue֤
bool SXBSchDoc::undo()
{
//printf("SXBSchDoc::undo() %d %d\n",m_nOpCount, m_nOldestOpCount);
	bool bResult = 	resetSelect();
	if(m_nOpCount <= m_nOldestOpCount){
		return bResult;
	}

	int nCount = m_listMain.size();
	if(nCount==0) return bResult;

	XBSchObjListIterator pObjIte =m_listMain.begin();
	while(nCount && pObjIte!=m_listMain.end()){
		if((*pObjIte)->placeNum() == m_nOpCount){ //UndoоݤΥ֥Ȥʤ...
			if((*pObjIte)->id() == SXBSchObj::ID_DELETEOBJ){		//   ⤷줬֥Ȥʤ
				(*pObjIte)->refObj()->setRefObj(NULL);				//		֥ȤλȤƤ륪֥ȤΤ
			}														//   ʤΤǡ褵
			delete (*pObjIte);										//UndoоݤΥ֥Ȥõ
			pObjIte = m_listMain.erase(pObjIte);					//erase()ǥȥΡɤϰĿʤ
		}else{
			pObjIte++;
		}
		nCount--;
	}

	m_nOpCount--;
	return true;
}

//Attributeѹǽ?
bool SXBSchDoc::canAttribute()
{
	int n=m_listTemp.size();
	if(n!=1) return false;
	XBSchObjListIterator pObjIte =m_listTemp.begin();
	return (*pObjIte)->canAttribute();
}

//ԡǽ
bool SXBSchDoc::canCopy()
{
	return (m_listTemp.size()>0);
}

//ǽ
bool SXBSchDoc::canDel()
{
	return (m_listTemp.size()>0);
}

//ڤǽ
bool SXBSchDoc::canCut()
{
	return (m_listTemp.size()>0);
}

/*
//Žդǽ
bool SXBSchDoc::canPaste()
{
	QString strID("+BSCH3_DATA_V.1.0");
	QClipboard *cb = QApplication::clipboard();
    QString str = cb->text().left(strID.length());	
	return (str == strID);
}
*/

//Undoǽ
bool SXBSchDoc::canUndo()
{
	return (m_nOpCount > m_nOldestOpCount);
}



//Rotate
bool SXBSchDoc::rotate()
{
	if(!canRotate()) return false;

	setupRotateRect();

	int n = m_listTemp.size();
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	if(n == 1){
		(*pObjIte)->rotate();
	}else{
		SPoint ptCenter = m_rcRotateRect.center();
		ptCenter.setX(((ptCenter.x()+5)/10)*10);
		ptCenter.setY(((ptCenter.y()+5)/10)*10);
		//int x=(m_rcRotateRect.l()+m_rcRotateRect.r())/2;
		//int y=(m_rcRotateRect.t()+m_rcRotateRect.bottom())/2;
		//SPoint ptCenter(x,y);
		while(pObjIte != m_listTemp.end()){
			(*pObjIte)->rotate(ptCenter);
			pObjIte++;
		}
	}
	setupRcTempArea();

	m_bDirty = true;	
	return true;
}

//쥤䡼ΰư
bool SXBSchDoc::moveToLayer(int nLayer)
{
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		(*pObjIte)->setLayer(nLayer);
		pObjIte++;
	}
	m_bDirty = true;	
	return true;
}


//Mirror
bool SXBSchDoc::mirror()
{
	if(!canMirror()) return false;

	setupRotateRect();

	int n = m_listTemp.size();
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	if(n == 1){
		(*pObjIte)->mirrorH();
	}else{
		int nCenter = (m_rcRotateRect.l()+m_rcRotateRect.r())/2;
		while(pObjIte != m_listTemp.end()){
			(*pObjIte)->mirrorH(nCenter);
			pObjIte++;
		}
	}
	setupRcTempArea();
	m_bDirty = true;	
	return true;
}


//Rotateǽ
bool SXBSchDoc::canRotate()
{
	if(m_listTemp.size() == 0) return false;
	if(m_bSelectForDrag) return false;
	return true;
}

//Mirrorǽ
bool SXBSchDoc::canMirror()
{
	if(m_listTemp.size() == 0) return false;
	if(m_bSelectForDrag) return false;
	return true;
}



//Ť̵ǡκ
//   ᥤΥꥹȤƬ饹󤷤ơꤷͤ
// 꾮ͤǤκԤä֥Ȥõ롣
//   ֥ȤȤб֥ȤΥꥹȤǤ
// ֤ܤȡʤ餺֥ȤƬ˶ᤤ
// ¸ߤ롣
void SXBSchDoc::delOldData(int nOpCount)
{
	bool bDel;
	resetSelect();
	if(nOpCount <= m_nOldestOpCount) return;
	
	int nDelObj=0;
	int nDelDelObj=0;


	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte!=m_listMain.end()){
		bDel = false;
		if((*pObjIte)->id() != SXBSchObj::ID_DELETEOBJ){
			if((*pObjIte)->refObj()!=NULL){
				SXBSchObj* pDelObj = (*pObjIte)->refObj();
				if(pDelObj->placeNum() < nOpCount){
					bDel = true;
					nDelObj++;
				}
			}
		}else{
			if((*pObjIte)->placeNum() < nOpCount){
				bDel = true;
				nDelDelObj++;
			}
		}
		if(bDel){
			delete (*pObjIte);						//UndoоݤΥ֥Ȥõ
			pObjIte = m_listMain.erase(pObjIte);	//erase()ǥȥΡɤϰĿʤ
		}else{
			pObjIte++;
		}
	}
	if(nOpCount > m_nOpCount) nOpCount = m_nOpCount;
	m_nOldestOpCount = nOpCount;

	//qDebug("delOldData(%d)   %d   %d",nOpCount,nDelObj,nDelDelObj);

	return;
}

//ꤷɸǡξ夫ɤ
int SXBSchDoc::isOnTempData(const SPoint& pt)
{
	if(m_listTemp.size() == 0) return 0;
	if(m_listTemp.size() == 1){
		XBSchObjListIterator pObjIte = m_listTemp.begin();
		int val= (*pObjIte)->qSelectWeight(pt) & (ON_OBJ|ON_NAME|ON_NUM);
		if(val)return val;
	}
	if(m_rcTempArea.intersect(pt)) 	return ON_OBJ;
	return 0;
}

//ǡư
void SXBSchDoc::moveTempData(int offsetx,int offsety)
{
	XBSchObjListIterator pObjIte = m_listTemp.begin();
	while(pObjIte != m_listTemp.end()){
		(*pObjIte)->move(offsetx,offsety);
		pObjIte++;
	}
	m_rcTempArea+=SPoint(offsetx,offsety);
	m_ptTempSnapPoint.setX(m_ptTempSnapPoint.x()+offsetx);
	m_ptTempSnapPoint.setY(m_ptTempSnapPoint.y()+offsety);
	m_bDirty = true;	
}

//ϰܹ򡣤٤Ƥܹ m_listWorkJunc Ф롣
//
void SXBSchDoc::selectForDragJunction(int scanMax,const SRect& rc)
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(scanMax>0 && pObjIte != m_listMain.end()){
		if(   (*pObjIte)->layer() == m_editLayer
		   && (*pObjIte)->id()==SXBSchObj::ID_JUNCTION 
		   && (*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			unsigned nSelStatus = (*pObjIte)->testSelection(rc);
			if(nSelStatus){
				SXBSchObj* pNewObj = (*pObjIte)->duplicate();	//򥪥֥Ȥʣ
				(*pObjIte)->setRefObj(pNewObj);					//쥪֥Ȥʣ֥Ȥ
				pNewObj->setRefObj(*pObjIte);					//֥Ȥ˸֥Ȥ
				pNewObj->setSelection(nSelStatus);				//֥Ȥե饰
				m_listTemp.push_back(pNewObj);					//֥Ȥǡݴ
			}
		}
		*pObjIte++;
		scanMax--;
	}
}

//٤Ƥܹ m_listWorkJunc Ф롣
void SXBSchDoc::pickupJunction(const SRect& )
{
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(pObjIte != m_listMain.end()){
		if(    (*pObjIte)->layer() == m_editLayer  
			&& (*pObjIte)->id()==SXBSchObj::ID_JUNCTION 
			&& (*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			m_listWorkJunc.push_back(*pObjIte);					//򳰤ܹȥꥢݴ
		}
		*pObjIte++;
	}
}



//ɥåΤܹ磻䡼ʳ
void SXBSchDoc::selectForDragExceptJuncWire(int scanMax,const SRect& rc)
{
	int scan=0;
	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(scan<scanMax && pObjIte != m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		  &&(*pObjIte)->id()!=SXBSchObj::ID_JUNCTION 
		  &&(*pObjIte)->id()!=SXBSchObj::ID_WIRE
		  &&(*pObjIte)->refObj()==NULL){
			unsigned nSelStatus = (*pObjIte)->testSelectionForDrag(rc);
			if(nSelStatus){
				SXBSchObj* pNewObj = (*pObjIte)->duplicate();	//򥪥֥Ȥʣ
				(*pObjIte)->setRefObj(pNewObj);					//쥪֥Ȥʣ֥Ȥ
				pNewObj->setRefObj(*pObjIte);					//֥Ȥ˸֥Ȥ
				pNewObj->setSelection(nSelStatus);				//֥Ȥե饰
				m_listTemp.push_back(pNewObj);					//֥Ȥǡݴ
				int pincount=pNewObj->pinCount();
				//qDebug("SXBSchDoc::selectForDragExceptJuncWire()  PINCOUNT=%d",pincount);
				for(int n=0;n<pincount;n++){
					SPoint pt=pNewObj->pinPosition(n);
					if(!rc.intersect(pt)){
						SRect rcPin(pt,pt);
						selectForDragJunction(scanMax,rcPin);
						selectForDragWire(scanMax,rcPin);
					}
				}
			}
		}
		*pObjIte++;
		scan++;
	}
}


//ɥåΤΥ磻䡼
void SXBSchDoc::selectForDragWire(int scanMax,const SRect& rc)
{
	SXBSchWire* pNewWire[5];

	int workWireCount= m_listWorkWire.size();	//m_listWorkWire뤬Ʊ rcɲäΤϺƥ󤷤ʤ
												//selectForDragǺǽϰϻǤΥ磻䡼ǤworkWireCount0ˤʤ롣

	XBSchObjListIterator pObjIte = m_listMain.begin();
	while(scanMax>0 && pObjIte != m_listMain.end()){
		if( (*pObjIte)->layer() == m_editLayer
		  &&(*pObjIte)->id()==SXBSchObj::ID_WIRE 
		  &&(*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			SXBSchWire* pObj= (SXBSchWire*)(*pObjIte);
			int divcount = divideWire(pObj,rc,pNewWire);
			if(divcount>0){
				SXBSchDelObj* pDelObj = new SXBSchDelObj;		//쥪֥Ȥõ뤿ξõ֥Ȥ
				(*pObjIte)->setRefObj(pDelObj);					//쥪֥Ȥ˾õ֥Ȥ
				pDelObj->setRefObj(*pObjIte);					//õ֥Ȥ˵쥪֥Ȥ
				pDelObj->setPlaceNum(m_nOpCount+1);				
				m_listMain.push_back(pDelObj);					//õ֥Ȥᥤǡݴ
				for(int n=0;n<divcount;n++){
					m_listWorkWire.push_back(pNewWire[n]);
				}
			}
		}
		*pObjIte++;
		scanMax--;
	}

	pObjIte = m_listWorkWire.begin();
	while(workWireCount>0 && pObjIte != m_listWorkWire.end()){
		if((*pObjIte)->refObj()==NULL){	//ȥ֥Ȥ¸ߤΤ̵Ǥ
			SXBSchWire* pObj= (SXBSchWire*)(*pObjIte);
			int divcount = divideWire(pObj,rc,pNewWire);
			if(divcount>0){
				(*pObjIte)->setRefObj(pNewWire[0]);
				for(int n=0;n<divcount;n++){
					m_listWorkWire.push_back(pNewWire[n]);
				}
			}
		}
		*pObjIte++;
		workWireCount--;
	}

}


//ɥåǤϥ磻䡼ʣduplicate()ǤϤʤdivideWire()ǹԤ
// ʣ줿֥Ȥˤե饰ꤵ롣
//磻䡼ɥåоݤǤʤʣʤ
//ɥåоݤɥåоݤʬ䤹ϥɥåоݤΤΤƬ˳Ǽ롣
int SXBSchDoc::divideWire(SXBSchWire* swire,const SRect& rc,SXBSchWire** dwire)
{
	int retval=0;
	bool vFlag;
	int fixval,jfix,jp;
	int p0,p1,p2,p3,p4,p5;
	int	boundaryMin,boundaryMax;
	unsigned int nSelStatus;
	unsigned int nOldSelStatus;

	if(!swire->qValid()) return 0;

	nOldSelStatus = (swire->selection() & (SXBSchObj::SELECT_P1|SXBSchObj::SELECT_P2));
	nSelStatus = swire->testSelectionForDrag(rc);

	//򤷤Τƥ󤹤뤹Υå
	if(nOldSelStatus){
		swire->setSelection(nOldSelStatus | nSelStatus);
		return 0;
	}

	nSelStatus = swire->testSelectionForDrag(rc);
	if((nSelStatus&(SXBSchObj::SELECT_P1|SXBSchObj::SELECT_P2)) ==SXBSchObj::SELECT_ALL){	//ξüϰΤȤ
		dwire[0] = (SXBSchWire*)(swire->duplicate());
		dwire[0]->setSelection(nSelStatus);
		return 1;
	}
	if(swire->x1()==swire->x2()){	//ľΤȤ
		if(swire->x1()<rc.l() || swire->x1()>rc.r()) return 0;	//ϰϳ
		if(swire->y1()<rc.t() && swire->y2()<rc.t()) return 0;	//ϰϳ
		if(swire->y1()>rc.b() && swire->y2()>rc.b()) return 0;	//ϰϳ
		vFlag = true;
		fixval = swire->x1();
		p0 = swire->y1();
		p5 = swire->y2();
		boundaryMin = rc.t();
		boundaryMax = rc.b();
	}else if(swire->y1()==swire->y2()){	//ʿΤȤ
		if(swire->y1()<rc.t() || swire->y1()>rc.b()) return 0;	//岼ϰϳ
		if(swire->x1()<rc.l() && swire->x2()<rc.l()) return 0;	//ϰϳ
		if(swire->x1()>rc.r() && swire->x2()>rc.r()) return 0;	//ϰϳ
		vFlag = false;
		fixval = swire->y1();
		p0 = swire->x1();
		p5 = swire->x2();
		boundaryMin = rc.l();
		boundaryMax = rc.r();
	}else{	//ФΤȤʬ䤷ʤ
		if(nSelStatus!=0){
			dwire[0]=(SXBSchWire*)(swire->duplicate());
			dwire[0]->setSelection(nSelStatus);
			return 1;
		}else{
			return 0;
		}
	}
	if(p0>p5){ int i=p5; p5=p0; p0=i; }

	p3=p1=p0;
	p2=p4=p5;

	if(p0>=boundaryMin) p2=p0;
	if(p5<=boundaryMax) p3=p5;
	XBSchObjListIterator pObjIte = m_listWorkJunc.begin();
	while(pObjIte != m_listWorkJunc.end()){
		SXBSchJunc* pJunc = (SXBSchJunc*)(*pObjIte);
		if(vFlag){  jfix = pJunc->x1();	jp	 = pJunc->y1();	}
		else{		jfix = pJunc->y1();	jp	 = pJunc->x1();	}
		if(jfix==fixval && jp>p1 && jp<p4){
			if(jp<boundaryMin){			//p1å(boundaryMin꾮ƺ)
				p1=jp;
			}else if(jp>boundaryMax){	//p4å(boundaryMax礭ƺǾ)
				p4=jp;
			}else{	//ܹϰ
				if(jp>p3) p3=jp;
				if(jp<p2) p2=jp;
			}
		}
		pObjIte++;
	}
	if(p2>p3){//ϰüܹʤʬ䤷ʤ
		return 0;
	}
	if(p2<p3){//ϰξüĥ磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p2));
			dwire[retval]->setP2(SPoint(fixval,p3));
		}else{
			dwire[retval]->setP1(SPoint(p2,fixval));
			dwire[retval]->setP2(SPoint(p3,fixval));
		}
		dwire[retval]->setSelection(SXBSchObj::SELECT_ALL);
		retval++;
	}
	if(p1<p2){//ϰP2üĥ磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p1));
			dwire[retval]->setP2(SPoint(fixval,p2));
		}else{
			dwire[retval]->setP1(SPoint(p1,fixval));
			dwire[retval]->setP2(SPoint(p2,fixval));
		}
		dwire[retval]->setSelection(SXBSchObj::SELECT_P2);
		retval++;
	}
	if(p3<p4){//ϰP1üĥ磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p3));
			dwire[retval]->setP2(SPoint(fixval,p4));
		}else{
			dwire[retval]->setP1(SPoint(p3,fixval));
			dwire[retval]->setP2(SPoint(p4,fixval));
		}
		dwire[retval]->setSelection(SXBSchObj::SELECT_P1);
		retval++;
	}
	if(p0<p1){//ϰϳ˥磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p0));
			dwire[retval]->setP2(SPoint(fixval,p1));
		}else{
			dwire[retval]->setP1(SPoint(p0,fixval));
			dwire[retval]->setP2(SPoint(p1,fixval));
		}
		retval++;
	}
	if(p4<p5){//ϰϳ˥磻䡼
		dwire[retval]=new SXBSchWire;
		if(vFlag){
			dwire[retval]->setP1(SPoint(fixval,p4));
			dwire[retval]->setP2(SPoint(fixval,p5));
		}else{
			dwire[retval]->setP1(SPoint(p4,fixval));
			dwire[retval]->setP2(SPoint(p5,fixval));
		}
		retval++;
	}
	return retval;
}


int SXBSchDoc::selectForDrag(const SRect& rc)
{
	//ǡβ
	resetSelect();
	m_listWorkJunc.clear();
	m_listWorkWire.clear();

	int scanMax = m_listMain.size();

	//ܹ
	pickupJunction(rc);
	selectForDragJunction(scanMax,rc);

	//磻䡼
	//ϰ⳰ˤޤΤϥ󥯥ˤʬԤ
	selectForDragWire(scanMax,rc);

	//ܹ磻䡼ʳ
	selectForDragExceptJuncWire(scanMax,rc);

	XBSchObjListIterator pObjIte = m_listWorkWire.begin();
	while(pObjIte != m_listWorkWire.end()){
		if((*pObjIte)->refObj()==NULL){	//ȥ֥ȤʤΤͭ
			if((*pObjIte)->selection()!=0){	//ե饰դƤΤϰǡ˥ԡ
				m_listTemp.push_back(*pObjIte);
			}else{
				(*pObjIte)->setPlaceNum(m_nOpCount+1);
				m_listMain.push_back(*pObjIte);
			}
		}else{
			delete(*pObjIte);
		}
		pObjIte++;
	}

	
	setupRcTempArea();
	setupRotateRect();
	m_listWorkJunc.clear();
	m_listWorkWire.clear();
	m_bSelectForDrag = true;
	return m_listTemp.size();
}
