// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#include <stdio.h>
#include <assert.h>

#include <qcolor.h>
#include <qpoint.h>
#include <qsize.h>
#include <qrect.h>
#include <qpainter.h>
#include <qpointarray.h>
#include <qfont.h>
#include <qfontinfo.h>




#include "xbschview.h"
#include "xbschdoc.h"
//#include "xbschpattern.h"
#include "xbsch.h"
#include "xbschobj.h"
#include "xbschjunc.h"
#include "xbschlabel.h"
#include "xbschcomment.h"
#include "xbschtag.h"
#include "xbschcomponent.h"
#include "drawcomponent.h"
#include "xbschglobal.h"


////////////////////////////////////////////
// ̤Υե졼Ϣ

// ե졼αοʿΥޡʸ(ABCD...)
void SXBSchView::drawFrameHMarks(QPainter*p,int y,int width,const QColor& color)
{
	int x=100;
	char str[2];
	str[0]='A';
	str[1]='\0';
	while(x<width){
		g_SmallFont.DrawText(p,x,y,str,color);
		x+=200;
		str[0]++;
	}
}

// ե졼αοľΥޡʸ(1234...)
void SXBSchView::drawFrameVMarks(QPainter*p,int x,int height,const QColor& color)
{
	int y=100;
	char str[2];
	str[0]='1';
	str[1]='\0';
	while(y<height){
		g_SmallFont.DrawText(p,x,y,str,color);
		y+=200;
		if(str[0]=='9') str[0]='0';
		else str[0]++;
	}
}

//ե졼
void SXBSchView::drawFrame(QPainter*p,const QRect& rcClip,const QColor& color)
{
	SSize size=m_pDoc->SheetSize();
	int h = size.h()/m_viewScale;
	int w = size.w()/m_viewScale;
	int fw = 10/m_viewScale;
	p->setRasterOp(CopyROP);
	QPen pen(color);
	p->setPen(pen);

	//ե졼
	if(rcClip.left()<=fw){
		p->drawLine(0,0,0,h-1);
		p->drawLine(fw,fw,fw,h-fw);
		if(m_viewScale==1)drawFrameVMarks(p,1,size.h(),color);
		//g_SmallFont.DrawText(p,50,50,"ABC",QColor("blue"),DRAW_ON);
	}
	//ե졼
	if(rcClip.right()>=(w-fw)){
		p->drawLine(w-1,0,w-1,h-1);
		p->drawLine(w-fw,fw,w-fw,h-fw);
		if(m_viewScale==1)drawFrameVMarks(p,size.w()-9,size.h(),color);
	}
	//ե졼
	if(rcClip.top()<=fw){
		p->drawLine(0,0,w-1,0);
		p->drawLine(fw,fw,w-fw,fw);
		if(m_viewScale==1)drawFrameHMarks(p,8,size.w(),color);
	}
	//ե졼
	if(rcClip.bottom()>=(h-fw)){
		p->drawLine(0,h-1,w-1,h-1);
		p->drawLine(fw,h-fw,w-fw,h-fw);
		if(m_viewScale==1)drawFrameHMarks(p,size.h()-2,size.w(),color);
	}
}

//åɤ
void SXBSchView::drawGrid(QPainter*p,const QRect& rcClip,const QColor& color)
{
	if(m_viewScale != 1) return;
	int l,t,r,b,x,y;

	//printf("SXBSchView::drawGrid() %d,%d \n",rcClip.left(),rcClip.top());

	SSize size=m_pDoc->SheetSize();

	l=(rcClip.left()/10)*10;
	t=(rcClip.top()/10)*10;
	r=rcClip.right();
	b=rcClip.bottom();

	if(l<20)l=20;
	if(t<20)t=20;
	if(r>(size.w()-20)) r=size.w()-20;
	if(b>(size.h()-20)) b=size.h()-20;


	p->setRasterOp(CopyROP);
	QPen pen(color);
	p->setPen(pen);
	for( x = l ; x <= r; x += 10){
		for( y = t; y <= b; y += 10){
			p->drawPoint(x,y);
		}
	}
}

//ǡΥե졼  						xbschdrawobject.cpp
void SXBSchView::drawTempDataFrame(QPainter*p)
{
	p->setRasterOp(Qt::XorROP);	QPen pen(QColor("white"),1,DotLine);
	p->setPen(pen);
	
	//QPen pen(QColor("gray"));
	//p->setPen(pen);
	QRect tempArea(m_pDoc->tempArea().l(),m_pDoc->tempArea().t(),m_pDoc->tempArea().w()+1,m_pDoc->tempArea().h()+1);
	p->drawRect(SheetToContents(tempArea));
}

//ΰ		  								xbschdrawobject.cpp
void SXBSchView::drawTempLine(QPainter*p)
{
	int width=1;
	if(m_toolmode == TOOL_BUS){
		if(m_viewScale == 1){
			width=3;
		}
	}
	
	PenStyle style=SolidLine;
	if(m_toolmode == TOOL_DASH){
		style=DotLine;
	}
	
	p->setRasterOp(Qt::XorROP);
	QPen pen(QColor("red"),width,style);
	p->setPen(pen);

	QPoint ptStart = m_ptLButtonDownAtSheet;
	if(m_bSnapGrid) ptStart = snapPoint(ptStart);
	ptStart = SheetToContents(ptStart);

	QPoint ptEnd = m_ptLastMoveAtSheet;
	if(m_bSnapGrid) ptEnd = snapPoint(ptEnd);
	ptEnd = SheetToContents(ptEnd);

	QPoint passPoint;
	if(m_nTempLineOrder >= 0){	//ʿ褹
		passPoint.setX(ptEnd.x());
		passPoint.setY(ptStart.y());
	}else{						//ľ褹
		passPoint.setX(ptStart.x());
		passPoint.setY(ptEnd.y());
	}
	p->moveTo(ptStart);
	p->lineTo(passPoint);
	p->lineTo(ptEnd);

}

//Ȥ
void SXBSchView::drawSelectFrame(QPainter*p)//,const QColor& color)
{
	p->setRasterOp(Qt::XorROP);
	QPen pen(QColor("white"),1,DotLine);
	p->setPen(pen);

	QPoint ptStart = SheetToContents(m_ptLButtonDownAtSheet);
	
	if(ptStart==m_ptLastMoveAtContents) return;		//2003/07/27
	QRect rc(ptStart,m_ptLastMoveAtContents);
	rc = rc.normalize();
	//printf("drawSelectFrame  %d   %d\n",rc.width(),rc.height());
	p->drawRect(rc);
}

//ꥹȾΥǡ xbschdrawobject.cpp
void SXBSchView::drawMainXBSchObj(QPainter*p,unsigned  nMode,SRect* prcClip)
{
	XBSchObjListIterator pObjIte = m_pDoc->m_listMain.begin();
	while(pObjIte != m_pDoc->m_listMain.end()){
		if((*pObjIte)->refObj() == NULL){	//ȥ֥Ȥ¸ߤʤΤ
			if(prcClip==NULL || (*pObjIte)->qRedraw(*prcClip)){
				drawXBSchObj(p,*pObjIte,nMode,prcClip);
			}
		}
		pObjIte++;
	}
}

void SXBSchView::drawTempXBSchObj(QPainter*p,unsigned  nMode,SRect* prcClip)
{
	XBSchObjListIterator pObjIte = m_pDoc->m_listTemp.begin();
	if(m_pDoc->m_listTemp.size()==1){
		nMode |= DRAW_SINGLE;
	}
	while(pObjIte != m_pDoc->m_listTemp.end()){
		if(prcClip==NULL || (*pObjIte)->qRedraw(*prcClip)){
			drawXBSchObj(p,*pObjIte,nMode,prcClip);
		}
		pObjIte++;
	}
}


void SXBSchView::drawXBSchObj(QPainter*p,SXBSchObj* pObj,unsigned  nMode,SRect* prcClip)
{
	if(!pObj) return;
	switch(pObj->id()){
	case SXBSchObj::ID_JUNCTION:
		drawJunction(p,pObj,nMode);
		break;
	case SXBSchObj::ID_LABEL:
		drawLabel(p,pObj,nMode);
		break;
	case SXBSchObj::ID_COMMENT:
		drawComment(p,pObj,nMode);
		break;
	case SXBSchObj::ID_TAG:
		drawTag(p,pObj,nMode);
		break;
	case SXBSchObj::ID_ENTRY:
	case SXBSchObj::ID_BENTRY:
	case SXBSchObj::ID_WIRE:
	case SXBSchObj::ID_DASH:
	case SXBSchObj::ID_BUS:
		drawLineData(p,pObj,nMode);
		break;
	case SXBSchObj::ID_COMPONENT:
		drawComponent(p,pObj,nMode,prcClip);
		break;
	default:
		break;
	}
}



//ˤĤޤȤ̥֥Ȥ˴Ϣ xbschdrawobject.cpp
void SXBSchView::drawCursorObj(QPainter*p)
{
	if(m_pCursorObj){
		drawXBSchObj(p,m_pCursorObj,DRAW_XOR,NULL);
	}
}




//
void SXBSchView::drawContents(QPainter*p,int clipx,int clipy,int clipw,int cliph)
{
	//qDebug("SXBSchView::drawContents\n");
	
	QRect rcClip = QRect(clipx,clipy,clipw,cliph);
	QRect rcClipSheet = ContentsToSheet(rcClip);	
	SRect srcClipSheet =SRect(rcClipSheet.left(),rcClipSheet.top(),rcClipSheet.width(),rcClipSheet.height());

	p->eraseRect(clipx,clipy,clipw,cliph);


	p->setClipping(true);
	contentsToViewport ( clipx,clipy,clipx,clipy);
	p->setClipRect(clipx,clipy,clipw,cliph);
	
	drawFrame(p,rcClip,QColor("black"));
	if(m_bDisplayGrid){
		drawGrid(p,rcClip,QColor("green4"));
	}
	
	//rcClip = SRect(prcClip->left(),prcClip->top(),prcClip->width(),prcClip->height())
	drawMainXBSchObj(p,DRAW_ON,&srcClipSheet);
	
	
	////////////////////////////////////////
	//p->setRasterOp(Qt::XorROP);
	//QPen pen(QColor("blue"));
	//p->setPen(pen);
	//p->setRasterOp(Qt::NotXorROP);
	
	
	//QRect rc(50,50,100,100);
	//rc = rc.normalize();
	//p->drawRect(rc);
	//rc = QRect(50,50,75,75);
	//p->drawRect(rc);
	////////////////////////////////////////
	
	
	//¾Τ٤Ƥ褬äƤXORԤ
	if(m_pDoc->m_listTemp.size()>0){
		if(m_bCompleteDrawTemp){	
			drawTempXBSchObj(p,DRAW_XOR,&srcClipSheet);
		}
		drawTempDataFrame(p);
	}
	if(m_bDrawSelectFrame) drawSelectFrame(p);
	if(m_bDrawTempLine)	drawTempLine(p);
	if(m_pCursorObj) drawCursorObj(p);

//	p->setPen(QColor("red"));
//	p->setRasterOp(XorROP);
//	p->drawText(100,100,"ABCDEFG"); 
//	p->drawText(100,130,QString::fromLocal8Bit("ABCDEFG")); 
}

	



//Ǥ
//󥯥
void SXBSchView::drawJunction(QPainter* p,SXBSchObj* pObj,unsigned  nMode)
{
	if(pObj->id() != SXBSchObj::ID_JUNCTION) return;
	
	SXBSchJunc* pJunc =(SXBSchJunc*)pObj;

	QColor col;
	RasterOp op = Qt::CopyROP;


	switch(nMode & 0xffff){
	case DRAW_ON:
		col = QColor("darkCyan");
		break;
	case DRAW_MONO:
		col = Qt::color1;
		break;
	case DRAW_OFF:
		col = QColor("white");
		break;
	case DRAW_XOR:
		col = QColor("red");
		op = Qt::XorROP;
		break;
	case DRAW_TEMP:
		col = QColor("red");
		break;
	}
	p->setRasterOp(op);
	int s = 2/m_viewScale;
	int w = s*2+1;
	int x = pJunc->x1()/m_viewScale;
	int y = pJunc->y1()/m_viewScale;

	if(s>0){
		p->fillRect(x-s,y-s,w,w,col);
	}else{
		p->setPen(col);
		p->drawPoint(x,y);
	}		
		
}


//Ǥ

//Ȥ
void SXBSchView::drawComment(QPainter* p,SXBSchObj* pObj,unsigned  nMode)
{
	if(pObj->id() != SXBSchObj::ID_COMMENT) return;
	
	SXBSchComment* pComment =(SXBSchComment*)pObj;
	QFont font;
	QColor col;
	QString strText;
	RasterOp op = Qt::CopyROP;
	
	if(strlen(pComment->fontName())>0){
		QString strFontName=QString::fromLocal8Bit(pComment->fontName());
		font = QFont(strFontName);
		QFontInfo fontinfo(font);
		if(fontinfo.family()==strFontName){
			//font.setPixelSize(pComment->fontSize());
			font.setBold(pComment->fontBold()!=0);
			font.setItalic(pComment->fontItalic()!=0);
			font.setStrikeOut(pComment->fontStrikeOut()!=0);
			font.setUnderline(pComment->fontUnderline()!=0);
		}else{
			font=m_defaultfont;
		}
	}else{
		font=m_defaultfont;
	}
	font.setPixelSize(pComment->fontSize());

	
	switch(nMode & 0xffff){
	case DRAW_ON:
		col = QColor("blue");
		break;
	case DRAW_MONO:
		col = Qt::color1;
		break;
	case DRAW_OFF:
		col = QColor("white");
		break;
	case DRAW_XOR:
	//case DRAW_XORINVERT:
		col = QColor("red");
		op = Qt::XorROP;
		break;
	case DRAW_TEMP:
	//case DRAW_XORINVERT:
		col = QColor("red");
		break;
	}

	p->setPen(col);
	p->setRasterOp(op);
	p->setFont(font);



	int h,w,x,y,voffset;
	x = pComment->x1()/m_viewScale;
	y = pComment->y1()/m_viewScale;

	QRect rcText=p->boundingRect (x,y,0,0,AlignLeft|AlignBottom ,QString::fromLocal8Bit(pComment->text()));
	w=rcText.width();
	h=rcText.height();
	
	QFontMetrics fontMetrics(font);
	voffset = fontMetrics.ascent();
	pComment->setDrawSize(voffset,SSize(w,h));

	if((nMode & 0xffff)==DRAW_XOR && m_viewScale <= 1){
		DrawXorText(p,			//
				 x,//-contentsX(),
				 y,//-contentsY(),
				 font,
				 QString::fromLocal8Bit(pComment->text()),
				 col,
				 w,
				 h);
		return;
	}
	
	if(m_viewScale <= 1){
		p->drawText(x,y,QString::fromLocal8Bit(pComment->text())); 
	}else{
		h /= m_viewScale;
		w /= m_viewScale;
		p->fillRect(x,y-voffset/m_viewScale,w,h,col);
	}

}



//٥
void SXBSchView::drawLabel(QPainter* p,SXBSchObj* pObj,unsigned  nMode)
{
	if(pObj->id() != SXBSchObj::ID_LABEL) return;
	
	SXBSchLabel* pLabel =(SXBSchLabel*)pObj;

	QColor col;
	RasterOp op = Qt::CopyROP;


	switch(nMode & 0xffff){
	case DRAW_ON:
		col = QColor("blue");
		break;
	case DRAW_MONO:
		col = Qt::color1;
		break;
	case DRAW_OFF:
		col = QColor("white");
		break;
	case DRAW_XOR:
	//case DRAW_XORINVERT:
		col = QColor("red");
		op = Qt::XorROP;
		break;
	case DRAW_TEMP:
		col = QColor("red");
		break;
	}
	p->setRasterOp(op);

	int h,w,x,y;


	if(pLabel->horizontal()){
		x = pLabel->x1()/m_viewScale;
		y = (pLabel->y1())/m_viewScale;
		if(m_viewScale <= 1){
			g_SmallFont.DrawText(p,x,y-2,pLabel->text(),col,nMode,false);
		}else{
			h = pLabel->area().h()/m_viewScale;
			w = pLabel->area().w()/m_viewScale;
			p->fillRect(x,y-h,w,h,col);
		}
	}else{
		x = pLabel->x1()/m_viewScale;
		y = (pLabel->y1())/m_viewScale;
		if(m_viewScale <= 1){
			g_SmallFont.DrawText(p,x-2,y,pLabel->text(),col,nMode,true);
		}else{
			h = pLabel->area().h()/m_viewScale;
			w = pLabel->area().w()/m_viewScale;
			p->fillRect(x,y-h,w,h,col);
		}
	}
}


//
void SXBSchView::drawTag(QPainter* p,SXBSchObj* pObj,unsigned  nMode)
{
	if(pObj->id() != SXBSchObj::ID_TAG) return;
	
	SXBSchTag* pTag =(SXBSchTag*)pObj;

	QColor colText;
	QColor colFrame;

	RasterOp op = Qt::CopyROP;


	switch(nMode & 0xffff){
	case DRAW_ON:
		colText = QColor("blue");
		colFrame = QColor("DarkGreen");
		break;
	case DRAW_MONO:
		colText = Qt::color1;
		colFrame = Qt::color1;
		break;
	case DRAW_OFF:
		colText = QColor("white");
		colFrame = QColor("white");
		break;
	case DRAW_XOR:
	//case DRAW_XORINVERT:
		colText = QColor("red");
		colFrame = QColor("red");
		op = Qt::XorROP;
		break;
	case DRAW_TEMP:
	//case DRAW_XORINVERT:
		colText = QColor("red");
		colFrame = QColor("red");
		break;
	}
	p->setRasterOp(op);
	
	int framex,framey,frameh,framew,textx,texty,textw;

	framex = pTag->x1()/m_viewScale;
	framey = pTag->y1()/m_viewScale;
	//hwϿʿΤȤ͡ľʤؤ롣
	frameh = 10/m_viewScale/2;
	framew = pTag->width()/m_viewScale;

	textw = strlen(pTag->text())*8;

	//ʸ
	if(pTag->horizontal()){
		if(m_viewScale <= 1){
			textx = pTag->x1()+(framew-textw)/2;
			texty = pTag->y1()+3;
			g_SmallFont.DrawText(p,textx,texty,pTag->text(),colText,nMode,false);
		}
	}else{
		if(m_viewScale <= 1){
			textx = pTag->x1()+3;
			texty = pTag->y1()-(framew-textw)/2;
			g_SmallFont.DrawText(p,textx,texty,pTag->text(),colText,nMode,true);
		}
	}

	//Ȥ
	QPointArray ptarray(6);
	int pointCount=0;
	int tagtype = pTag->tagType();
	//뤬̾ΤȤϡϾĹ褹롣
	if(m_viewScale > 1){
		tagtype =SXBSchTag::TAG_SQ;
	}
	if(pTag->horizontal()){
		switch(tagtype){
		case SXBSchTag::TAG_SQ:
			pointCount=4;
			ptarray.setPoint(0,framex,			framey-frameh);
			ptarray.setPoint(1,framex + framew,	framey-frameh);
			ptarray.setPoint(2,framex + framew,	framey+frameh);
			ptarray.setPoint(3,framex,			framey+frameh);
			break;
		case SXBSchTag::TAG_BI:
			pointCount=6;
			ptarray.setPoint(0,framex,					framey		 );
			ptarray.setPoint(1,framex + frameh,			framey-frameh);
			ptarray.setPoint(2,framex + framew - frameh,framey-frameh);
			ptarray.setPoint(3,framex + framew,			framey		 );
			ptarray.setPoint(4,framex + framew - frameh,framey+frameh);
			ptarray.setPoint(5,framex + frameh,			framey+frameh);
			break;
		case SXBSchTag::TAG_LU:
			pointCount=5;
			ptarray.setPoint(0,framex,					framey		 );
			ptarray.setPoint(1,framex + frameh,			framey-frameh);
			ptarray.setPoint(2,framex + framew,			framey-frameh);
			ptarray.setPoint(3,framex + framew,			framey+frameh);
			ptarray.setPoint(4,framex + frameh,			framey+frameh);
			break;
		case SXBSchTag::TAG_RD:
			pointCount=5;
			ptarray.setPoint(0,framex,					framey-frameh);
			ptarray.setPoint(1,framex + framew - frameh,framey-frameh);
			ptarray.setPoint(2,framex + framew,			framey		 );
			ptarray.setPoint(3,framex + framew - frameh,framey+frameh);
			ptarray.setPoint(4,framex,					framey+frameh);
			break;
		}
	}else{
		switch(tagtype){
		case SXBSchTag::TAG_SQ:
			pointCount=4;
			ptarray.setPoint(0,framex - frameh,	framey		 );
			ptarray.setPoint(1,framex - frameh,	framey-framew);
			ptarray.setPoint(2,framex + frameh,	framey-framew);
			ptarray.setPoint(3,framex + frameh,	framey		 );
			break;
		case SXBSchTag::TAG_BI:
			pointCount=6;
			ptarray.setPoint(0,framex,			framey					);
			ptarray.setPoint(1,framex - frameh,	framey -frameh			);
			ptarray.setPoint(2,framex - frameh,	framey -framew + frameh	);
			ptarray.setPoint(3,framex,			framey -framew			);
			ptarray.setPoint(4,framex + frameh,	framey -framew + frameh	);
			ptarray.setPoint(5,framex + frameh,	framey -frameh			);
			break;
		case SXBSchTag::TAG_LU:
			pointCount=5;
			ptarray.setPoint(0,framex - frameh,	framey					);
			ptarray.setPoint(1,framex - frameh,	framey -framew + frameh	);
			ptarray.setPoint(2,framex,			framey -framew			);
			ptarray.setPoint(3,framex + frameh,	framey -framew + frameh	);
			ptarray.setPoint(4,framex + frameh,	framey					);
			break;
		case SXBSchTag::TAG_RD:
			pointCount=5;
			ptarray.setPoint(0,framex,			framey			);
			ptarray.setPoint(1,framex - frameh,	framey -frameh	);
			ptarray.setPoint(2,framex - frameh,	framey-framew	);
			ptarray.setPoint(3,framex + frameh,	framey-framew	);
			ptarray.setPoint(4,framex + frameh,	framey -frameh	);
			break;
		}
	}
	p->setRasterOp(op);
	QPen pen(colFrame,1,SolidLine); 
	p->setPen(pen);
	QBrush brush(NoBrush);
	p->setBrush(brush);
	p->drawPolygon(ptarray,false,0,pointCount);
}


//
void SXBSchView::drawLineData(QPainter* p,SXBSchObj* pObj,unsigned  nMode)
{
	int width = 1;
	PenStyle style = Qt::SolidLine;
	QColor col;
	RasterOp op = Qt::CopyROP;

	switch(pObj->id()){
	  case SXBSchObj::ID_WIRE:
		col = QColor("darkCyan");
		break;
		
	case SXBSchObj::ID_ENTRY:
		col = QColor("darkCyan");
		break;
	  case SXBSchObj::ID_DASH:
		//style = Qt::DotLine;
		col = QColor("gray");
		break;
	case SXBSchObj::ID_BUS:
	case SXBSchObj::ID_BENTRY:
		if(m_viewScale < 2) width=3;
		col = QColor("darkGreen");
		break;
	default:
		return;
	}


	switch(nMode & 0xffff){
	case DRAW_ON:
		break;
	  case DRAW_MONO:
		if(pObj->id()==SXBSchObj::ID_DASH){
			col = QColor("gray");
		}else{
			col = Qt::color1;
		}
		break;
	case DRAW_OFF:
		col = QColor("white");
		break;
	case DRAW_XOR:
	//case DRAW_XORINVERT:
		col = QColor("white");
		op = Qt::XorROP;
		break;
	case DRAW_TEMP:
		col = QColor("red");
		break;
	
	}

	p->setRasterOp(op);
	int x1 = pObj->x1()/m_viewScale;
	int y1 = pObj->y1()/m_viewScale;
	int x2 = pObj->x2()/m_viewScale;
	int y2 = pObj->y2()/m_viewScale;


	QPen pen(col,width,style); 
	p->setPen(pen);
	p->drawLine(x1,y1,x2,y2);
}

//ʤ
void SXBSchView::drawComponent(QPainter* p,SXBSchObj* pObj,unsigned  nMode,SRect* prcClip)
{
	g_drawComponent(p,(SXBSchComponent*)pObj,nMode,prcClip,m_viewScale);
}