// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
/****************************************************************************
** XBSchǥ٥륯饹μ
****************************************************************************/
#include <stdio.h>
#include <assert.h>
#include <string>
using namespace std;
#include "ce3io.h"
#include "xbschobj.h"
#include "xbschlabel.h"


//󥹥ȥ饯
SXBSchLabel::SXBSchLabel()
{
	m_bHoriz = true;
}

bool SXBSchLabel::readCe3(SReadCE3& rce3,const SPoint* pptOrigin,SXBSchDoc*)
{
	string str;
	bool bInitX1 = false;
	bool bInitY1 = false;
	bool bInitDir = false;
	bool bInitText = false;

	while(1){
		if(rce3.ReadRecord(str)==EOF) return false;
		if(str[0] == '-'){
			if( (str != "-LABEL") || !bInitX1 || !bInitY1 || !bInitDir || !bInitText){
				return false;
			}else{
				break;	//break while(1){ }
			}
		}else if(str[0] == '+'){
			str[0]='-';
			if(rce3.SkipTo(str)==EOF) return false;
		}else{
			int n;
			int l=str.length();
			for(n=0;n<l;n++){
				if(str[n]==':') break;
			}
			if(0<n && n<(l-1)){	// : ʬ줿쥳ɤǤ
				string var = str.substr(0,n);				//Ƭ:μޤ
				int nParam = atoi(str.substr(n+1).c_str()); //:齪üޤǤͤѴ

#ifdef _BSCH	//Qt-BSch doesn't support layer.
				if(var=="L"){
					if(isValidLayer(nParam)){
						m_Layer	= nParam;			
					}
				}else
#endif
				if(var=="X"){
					if(pptOrigin) nParam += pptOrigin->x();		
					m_p1.setX(nParam);
					bInitX1 = true;
				}else
				if(var=="Y"){
					if(pptOrigin) nParam += pptOrigin->y();		
					m_p1.setY(nParam);
					bInitY1 = true;
				}else
				if(var=="D"){
					if(nParam==0)	m_bHoriz = false;
					else			m_bHoriz = true;
					bInitDir = true;
				}else
				if(var=="S"){
					m_strText=str.substr(n+1);
					//if(m_strText.length()>0){
						bInitText = true;
					//}
				}
			}
		}
	}

	return true;
}

bool SXBSchLabel::writeCe3(SWriteCE3& wce3,const SPoint* pptOrigin)
{
	int x = m_p1.x();
	int y = m_p1.y();
	int d = (m_bHoriz ? 1 : 0);
	if(pptOrigin){
		x -= pptOrigin->x();
		y -= pptOrigin->y();
	}

	wce3.WriteRecord("+LABEL");
	wce3.WriteRecordInt("L",m_Layer);
	wce3.WriteRecordInt("X",x);
	wce3.WriteRecordInt("Y",y);
	wce3.WriteRecordInt("D",d);
	wce3.WriteRecordString("S",m_strText);

	wce3.WriteRecord("-LABEL");
	wce3.WriteEOL();
	return true;
}


//ʣԤ
SXBSchObj* SXBSchLabel::duplicate()
{
	SXBSchObj* newObj =new SXBSchLabel(*this);
	return newObj;
}

//ꤷ٤֤
int SXBSchLabel::qSelectWeight(const SPoint& p)
{
	int nResult = PointAndRectMag(p,area());
	if(nResult) return (nResult | ON_OBJ);
	else		return 0;
}

//ϰϤꤷԤ
unsigned SXBSchLabel::testSelection(const SRect& rc)
{
	if( rc.intersect(area()) ){
		return SELECT_ALL;
	}else{
		return 0;
	}
}

//ϰϤ򤷤ƥɥåԤ
unsigned SXBSchLabel::testSelectionForDrag(const SRect& rc)
{
	if( rc.intersect(area()) ){
		return SELECT_ALL;
	}else{
		return 0;
	}
}

//褬ɬפɤ֤
bool SXBSchLabel::qRedraw(const SRect& rc)
{
	return rc.intersect(area());
}

//ͭϰϤ֤
SRect SXBSchLabel::area()
{
	int length=m_strText.length()*8;

	if(m_bHoriz){
		return SRect(m_p1.x(),m_p1.y()-10,length,10);
	}else{
		return SRect(m_p1.x()-10,m_p1.y()-length,10,length);
	}
}

SRect SXBSchLabel::rotateRect()
{
	return SRect(m_p1,m_p1);
}

//XY濴ɸꤷơžԤ
void SXBSchLabel::rotate(const SPoint& p)
{
	m_bHoriz = !m_bHoriz;	
	SXBSchObj::rotate(p);
}

//žԤ
void SXBSchLabel::rotate()
{
	rotate(m_p1);
}

//ƥȤ
void SXBSchLabel::setText(const char* psz)
{
	if(psz == NULL){
		m_strText = "";
	}else{
		m_strText = psz;
	}
}

