// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#include <qpaintdevice.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qimage.h>
#include <string.h>
#include <stdio.h>
#include "xbsch.h"
#include "xbschpattern.h"
//#include "xbschview.h"



void DrawBitmap(
		QPainter* pPainter,			//
		const QBitmap* pBmp,		//Ϥӥåȥޥåײ
		int x,
		int y,						//ϰ
		const QColor& color,		//Ͽ
		unsigned  nMode)			//⡼
{
	int width=pBmp->width();
	int height=pBmp->height();
	//QImage  img = pBmp->convertToImage();	//᡼Ѵ
	//img.convertDepth (8);					//顼᡼Ѵ
	QPixmap Pmp(width,height);
	
	pPainter->setRasterOp(Qt::CopyROP);

	switch(nMode & 0xffff){
	  case DRAW_ON:
		Pmp.fill(color);
		//img.setColor(0,(QRgb)0xFFFFFFFF);
		//img.setColor(1,color.rgb());
		//Pmp = QPixmap(img);
		Pmp.setMask(*pBmp);
		//pPainter->setRasterOp(Qt::AndROP);
		//bitBlt ( pPainter->device(), x, y, &Pmp, 0, 0, width, height, Qt::CopyROP,FALSE) ;
		//bitBlt ( pPainter, QPoint(x,y), const QPaintDevice * src, const QRect & sr, RasterOp rop ) 
		pPainter->drawPixmap(x,y,Pmp,0,0);
		break;

	  case DRAW_OFF:
		Pmp.fill(QColor("white"));
		Pmp.setMask(*pBmp);
		pPainter->drawPixmap(x,y,Pmp,0,0);
//		img.setColor(0,(QRgb)0);
//		img.setColor(1,(QRgb)0xFFFFFFFF);
//		pPainter->setRasterOp(Qt::OrROP);
//		pPainter->drawImage(x,y,img,0,0);
		break;

	  case DRAW_MONO:
		Pmp.fill(QColor("black"));
		Pmp.setMask(*pBmp);
		pPainter->drawPixmap(x,y,Pmp,0,0);
		
		//img.setColor(0,(QRgb)0xFFFFFFFF);
		//img.setColor(1,(QRgb)0);
		//pPainter->setRasterOp(Qt::AndROP);
		//pPainter->drawImage(x,y,img,0,0);
		break;

	case DRAW_XOR:
	case DRAW_XORINVERT:
		//Pmp.fill(QColor("white"));
		//Pmp.fill(color);
		Pmp.fill(QColor("red"));
		Pmp.setMask(*pBmp);
		pPainter->setRasterOp(Qt::XorROP);
		pPainter->drawPixmap(x,y,Pmp,0,0);
		break;
		
	case DRAW_TEMP:
		Pmp.fill(color);
		Pmp.setMask(*pBmp);
		pPainter->drawPixmap(x,y,Pmp,0,0);

		//img.setColor(0,QColor("white").rgb());
		//img.setColor(1,color.rgb());
		//pPainter->setRasterOp(Qt::NotXorROP);
		//pPainter->drawImage(x,y,img,0,0);
		break;

	//case DRAW_XORINVERT:
	//	img.setColor(1,QColor("black").rgb());
	//	img.setColor(0,~color.rgb());
	//	pPainter->setRasterOp(Qt::XorROP);
	//	pPainter->drawImage(x,y,img,0,0);
	//	break;

	}
}


void DrawXorText(QPainter* pPainter,			//
				 int x,
				 int y,
				 const QFont& font,
				 const QString& str,
				 const QColor& col,
				 int w,
				 int h)
{
	int imageH=(h*3)/2;
	QPixmap buffer(w,imageH);
	QPainter painter;
	painter.begin(&buffer);
	painter.setPen(col);
	painter.setFont(font);
	painter.eraseRect(0,0,w,imageH);
	painter.drawText(0,h,str);
	QImage  img = buffer.convertToImage();	//᡼Ѵ
	pPainter->setRasterOp(Qt::XorROP);
	pPainter->drawImage(x,y-h,img,0,0);

}




///////////////////////////////////////////////////////////
// XBSchΥ⡼եȥ饹Υץ


unsigned char SSmallFont::Font88h[95*8]={
/* 0x20 */
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
/* 0x21 */
0x00,0x38,0x38,0x38,0x10,0x10,0x00,0x10,
/* 0x22 */
0x00,0x28,0x28,0x28,0x00,0x00,0x00,0x00,
/* 0x23 */
0x00,0x28,0x28,0xFE,0x28,0xFE,0x28,0x28,
/* 0x24 */
0x00,0x10,0x7C,0x90,0x7C,0x12,0x7C,0x10,
/* 0x25 */
0x00,0xE2,0xA4,0xE8,0x10,0x2E,0x4A,0x8E,
/* 0x26 */
0x00,0x30,0x48,0x48,0x30,0x4A,0x44,0x3A,
/* 0x27 */
0x00,0x38,0x38,0x08,0x10,0x00,0x00,0x00,
/* 0x28 */
0x00,0x10,0x20,0x20,0x20,0x20,0x20,0x10,
/* 0x29 */
0x00,0x10,0x08,0x08,0x08,0x08,0x08,0x10,
/* 0x2A */
0x00,0x00,0x10,0x54,0x38,0x38,0x54,0x10,
/* 0x2B */
0x00,0x10,0x10,0x10,0xFE,0x10,0x10,0x10,
/* 0x2C */
0x00,0x00,0x00,0x00,0x60,0x60,0x20,0x40,
/* 0x2D */
0x00,0x00,0x00,0x00,0xFE,0x00,0x00,0x00,
/* 0x2E */
0x00,0x00,0x00,0x00,0x00,0x00,0x60,0x60,
/* 0x2F */
0x00,0x02,0x04,0x08,0x10,0x20,0x40,0x80,
/* 0x30 */
0x00,0x7C,0x86,0x8A,0x92,0xA2,0xC2,0x7C,
/* 0x31 */
0x00,0x10,0x30,0x10,0x10,0x10,0x10,0x38,
/* 0x32 */
0x00,0x7C,0x82,0x02,0x0C,0x30,0x40,0xFE,
/* 0x33 */
0x00,0xFE,0x04,0x08,0x1C,0x02,0x82,0x7C,
/* 0x34 */
0x00,0x18,0x28,0x48,0x88,0xFE,0x08,0x08,
/* 0x35 */
0x00,0xFE,0x80,0xFC,0x02,0x02,0x02,0xFC,
/* 0x36 */
0x00,0x38,0x40,0x80,0xFC,0x82,0x82,0x7C,
/* 0x37 */
0x00,0xFE,0x82,0x04,0x08,0x10,0x10,0x10,
/* 0x38 */
0x00,0x7C,0x82,0x82,0x7C,0x82,0x82,0x7C,
/* 0x39 */
0x00,0x7C,0x82,0x82,0x7C,0x04,0x08,0x10,
/* 0x3A */
0x00,0x18,0x18,0x00,0x00,0x00,0x18,0x18,
/* 0x3B */
0x18,0x18,0x00,0x00,0x18,0x18,0x08,0x10,
/* 0x3C */
0x00,0x06,0x18,0x60,0x80,0x60,0x18,0x06,
/* 0x3D */
0x00,0x00,0x00,0xFE,0x00,0x00,0xFE,0x00,
/* 0x3E */
0x00,0xC0,0x30,0x0C,0x02,0x0C,0x30,0xC0,
/* 0x3F */
0x00,0x7C,0x82,0x82,0x0C,0x10,0x00,0x10,
/* 0x40 */
0x00,0x7C,0x82,0x9E,0x92,0x92,0x92,0x5C,
/* 0x41 */
0x00,0x38,0x44,0x82,0x82,0xFE,0x82,0x82,
/* 0x42 */
0x00,0xFC,0x82,0x82,0xFC,0x82,0x82,0xFC,
/* 0x43 */
0x00,0x7C,0x82,0x80,0x80,0x80,0x82,0x7C,
/* 0x44 */
0x00,0xF8,0x84,0x82,0x82,0x82,0x84,0xF8,
/* 0x45 */
0x00,0xFE,0x80,0x80,0xF8,0x80,0x80,0xFE,
/* 0x46 */
0x00,0xFE,0x80,0x80,0xF8,0x80,0x80,0x80,
/* 0x47 */
0x00,0x7C,0x82,0x80,0x9E,0x82,0x82,0x7C,
/* 0x48 */
0x00,0x82,0x82,0x82,0xFE,0x82,0x82,0x82,
/* 0x49 */
0x00,0x7C,0x10,0x10,0x10,0x10,0x10,0x7C,
/* 0x4A */
0x00,0x02,0x02,0x02,0x02,0x82,0x82,0x7C,
/* 0x4B */
0x00,0x82,0x84,0x88,0x90,0xA8,0xC4,0x82,
/* 0x4C */
0x00,0x80,0x80,0x80,0x80,0x80,0x80,0xFE,
/* 0x4D */
0x00,0x82,0xC6,0xAA,0x92,0x82,0x82,0x82,
/* 0x4E */
0x00,0x82,0xC2,0xA2,0x92,0x8A,0x86,0x82,
/* 0x4F */
0x00,0x7C,0x82,0x82,0x82,0x82,0x82,0x7C,
/* 0x50 */
0x00,0xFC,0x82,0x82,0xFC,0x80,0x80,0x80,
/* 0x51 */
0x00,0x7C,0x82,0x82,0x92,0x8A,0x84,0x7A,
/* 0x52 */
0x00,0xFC,0x82,0x82,0xFC,0x88,0x84,0x82,
/* 0x53 */
0x00,0x7E,0x80,0x80,0x7C,0x02,0x02,0xFC,
/* 0x54 */
0x00,0xFE,0x10,0x10,0x10,0x10,0x10,0x10,
/* 0x55 */
0x00,0x82,0x82,0x82,0x82,0x82,0x82,0x7C,
/* 0x56 */
0x00,0x82,0x82,0x82,0x82,0x44,0x28,0x10,
/* 0x57 */
0x00,0x82,0x82,0x82,0x82,0x92,0xAA,0x44,
/* 0x58 */
0x00,0x82,0x44,0x28,0x10,0x28,0x44,0x82,
/* 0x59 */
0x00,0x82,0x44,0x28,0x10,0x10,0x10,0x10,
/* 0x5A */
0x00,0xFE,0x04,0x08,0x10,0x20,0x40,0xFE,
/* 0x5B */
0x00,0x3C,0x20,0x20,0x20,0x20,0x20,0x3C,
/* 0x5C */
0x00,0x80,0x40,0x20,0x10,0x08,0x04,0x02,
/* 0x5D */
0x00,0x78,0x08,0x08,0x08,0x08,0x08,0x78,
/* 0x5E */
0x00,0x38,0x44,0x82,0x82,0x44,0x28,0xEE,
/* 0x5F */
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFE,
/* 0x60 */
0x00,0x00,0x00,0x24,0x24,0x24,0x5A,0x80,
/* 0x61 */
0x00,0x00,0x00,0x7C,0x02,0x7E,0x82,0x7E,
/* 0x62 */
0x00,0x80,0x80,0xBC,0xC2,0x82,0xC2,0xBC,
/* 0x63 */
0x00,0x00,0x00,0x7C,0x82,0x80,0x80,0x7E,
/* 0x64 */
0x00,0x02,0x02,0x7A,0x86,0x82,0x86,0x7A,
/* 0x65 */
0x00,0x00,0x00,0x7C,0x82,0xFE,0x80,0x7E,
/* 0x66 */
0x00,0x1C,0x22,0x20,0xFE,0x20,0x20,0x20,
/* 0x67 */
0x00,0x00,0x00,0x7A,0x86,0x7A,0x02,0xFC,
/* 0x68 */
0x00,0x80,0x80,0xBC,0xC2,0x82,0x82,0x82,
/* 0x69 */
0x00,0x10,0x00,0x30,0x10,0x10,0x10,0x7C,
/* 0x6A */
0x00,0x04,0x00,0x0C,0x04,0x04,0x44,0x38,
/* 0x6B */
0x00,0x80,0x80,0x86,0x98,0xE8,0x84,0x82,
/* 0x6C */
0x00,0x70,0x10,0x10,0x10,0x10,0x10,0xFE,
/* 0x6D */
0x00,0x00,0x00,0xEC,0x92,0x92,0x92,0x92,
/* 0x6E */
0x00,0x00,0x00,0xBC,0xC2,0x82,0x82,0x82,
/* 0x6F */
0x00,0x00,0x00,0x7C,0x82,0x82,0x82,0x7C,
/* 0x70 */
0x00,0x00,0x00,0xBC,0xC2,0xC2,0xBC,0x80,
/* 0x71 */
0x00,0x00,0x00,0x7A,0x86,0x86,0x7A,0x02,
/* 0x72 */
0x00,0x00,0x00,0xBC,0xC2,0x80,0x80,0x80,
/* 0x73 */
0x00,0x00,0x00,0x7E,0x80,0xFE,0x02,0xFC,
/* 0x74 */
0x00,0x20,0x20,0xFE,0x20,0x20,0x22,0x1C,
/* 0x75 */
0x00,0x00,0x00,0x82,0x82,0x82,0x86,0x7A,
/* 0x76 */
0x00,0x00,0x00,0x82,0x82,0x44,0x28,0x10,
/* 0x77 */
0x00,0x00,0x00,0x82,0x92,0x92,0x92,0x6C,
/* 0x78 */
0x00,0x00,0x00,0xC6,0x28,0x10,0x28,0xC6,
/* 0x79 */
0x00,0x00,0x00,0x82,0x86,0x7A,0x02,0x7C,
/* 0x7A */
0x00,0x00,0x00,0xFE,0x04,0x38,0x40,0xFE,
/* 0x7B */
0x00,0x1C,0x20,0x20,0x40,0x20,0x20,0x1C,
/* 0x7C */
0x00,0x10,0x10,0x10,0x00,0x10,0x10,0x10,
/* 0x7D */
0x00,0x70,0x08,0x08,0x04,0x08,0x08,0x70,
/* 0x7E */
0x00,0x00,0x00,0x60,0x92,0x0C,0x00,0x00
};

////////////////////////////////////////////////////////////////////////////////
// SSmallFont Υ󥹥ȥ饯
SSmallFont::SSmallFont()
{
	Init88Font();
	m_pBmpBit=new unsigned char [4096];
}

////////////////////////////////////////////////////////////////////////////////
// SSmallFont Υǥȥ饯
SSmallFont::~SSmallFont()
{
	delete[]pFont88v;
	delete[]m_pBmpBit;
}

// ߣɥåȥեȤν
void SSmallFont::Init88Font()
{
	int		n;	//եȤΥ
	int		x,y;
	unsigned char *pSrc,*pDest;
	unsigned char Smask;
	unsigned char Dmask;
	
	pFont88v=new unsigned char [95*8];
	for(n=0;n<95;n++){
		Smask=1;
		for(y=0;y<8;y++){
			pSrc    =  Font88h+8*n;
			pDest   = pFont88v+8*n+y;
			Dmask=0x80;
			*pDest=0;
			for(x=0;x<8;x++){
				if(*pSrc & Smask) *pDest |= Dmask;
				Dmask>>=1;
				pSrc++;
			}
			Smask<<=1;
		}
	}
}




////////////////////////////////////////////////////////////
//   ʸν		ϣХʬ
//		 0 1 2 3 4 5 6 7
//	  0    
//	  1 
//	  2 
//	  3 
//	  4 
//	  5 
//	  6 
//	  7 
//	  8 
////////////////////////////////////////////////////////////
void SSmallFont::SetToBuffH(bool nInv)
{

	int	n;
	int	y;
	unsigned char* pS;	//եȥǡΥݥ
	unsigned char* pD;	//ŸХåեΥݥ
	const char*	pChar;
	

	m_nBuffXByte = (m_nStrLen+1)&0xfffe;	//ΥХȿ϶
//	m_nBuffXByte = m_nStrLen
	m_nBuffXDot  = m_nBuffXByte*8;			//Υɥåȿ
	m_nBuffYDot  = 9;						//Υɥåȿ
	
	unsigned char  cInv;
	if(nInv)cInv=0xff; else cInv=0;
	
	pChar=m_pString;
	for(n=0;n<m_nStrLen;n++){
		pD=m_pBmpBit+n;						//ŸХåեΥݥ󥿤
		if(*pChar&0x80)*pD=0xff;else *pD=0;	//ʸ0x80ΥӥåȤʤ
		*pD ^= cInv;
		int nOffset = *pChar&0x7f;
		if(nOffset<0x20 || nOffset>0x7e) nOffset=0x20; //2002.07.03
		pS=Font88h+(nOffset-0x20)*8;	//եȥǡΥݥ󥿤
		for(y=0;y<8;y++){			//ʸʬΥեȥǡΥԡ
			pD+=m_nBuffXByte;			//Хȥԡ뤿Ӥˣ饤ʬΥХȿʤ
			*pD=*pS;					//Хȥԡ
			*pD ^= cInv;
			pS++;						//եȥǡϣХȥ󥯥
		}
		pChar++;						//ʸ
	}
	//ʸξ硢ĤΥХåեΥꥢ롣
	if(n<m_nBuffXByte){			
		pD=m_pBmpBit+n;				//ХåեΥݥ󥿤
		for(y=0;y<9;y++){
			*pD=0;
			pD+=m_nBuffXByte;
		}
	}
}

////////////////////////////////////////////////////////////
//   Ľʸν
//
//	7 
//	6 
//	5 
//	4 
//	3 
//	2 
//	1 
//	0 
//	   0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5
////////////////////////////////////////////////////////////
void SSmallFont::SetToBuffV(bool nInv)
{
	int	n;
	int	y;
	unsigned char* pS;	//եȥǡΥݥ
	unsigned char* pD;	//ŸХåեΥݥ
	const char*	pChar;
	unsigned char cUpper ;	//ʸξ

	m_nBuffXByte = 2;			//ΥХȿϣ
	m_nBuffXDot  = 16;			//Υɥåȿ
	m_nBuffYDot  = m_nStrLen*8;	//Υɥåȿ
	
	unsigned char  cInv;
	if(nInv)cInv=0xff; else cInv=0;
	

	pChar=m_pString;
	pD=m_pBmpBit+m_nBuffYDot*2-1;	//ŸХåեΥݥ󥿤Ÿɥ쥹ϰϤκǸ
	for(n=0;n<m_nStrLen;n++){
		if(*pChar&0x80)cUpper=1;else cUpper=0;	//0x80ΥӥåȤʤ
		if(nInv) cUpper ^= 1;
		int nOffset = *pChar&0x7f;
		if(nOffset<0x20 || nOffset>0x7e) nOffset=0x20; //2002.07.03
		pS=pFont88v+(nOffset-0x20)*8+7;	//եȥǡΥݥ󥿤
		for(y=0;y<8;y++){
			*pD=*pS--;				//եȥǡΥԡ
			*pD ^= cInv;
			pD--;
			*pD--=cUpper;			//ղ
		}
		pChar++;		//ʸ
	}
}



//	BSch8ɥåʸ
void SSmallFont::DrawText(	
		QPainter* pPainter,			//
		int x,
		int y,						//ϰ
		const char* str,			//ʸ
		const QColor& color,		//Ͽ
		unsigned  nMode/*=DRAW_ON*/,//⡼
		bool bVert /*=false*/,		//ľե饰
		bool bPointFront/*=true*/,	//ꤷϰ֤ʸǤTRUE
		int )				//1/nDivisor˽̾ɽ1礭ȤʸĹ褹
{
//	COLORREF colOldText,colOldBk;
//	CSize sizeLog;
	
//	int cx;
//	int cy;

	m_nStrLen=strlen(str);		//ʸĹ
	if(m_nStrLen==0) return;		//ʸĹʤ鲿⤷ʤ
	if(m_nStrLen>255) m_nStrLen=255;//ʸĹϺ255ʸ


/*
	/////////////////////////////////////////////////////////////////////
	//̾ɽ  ͳѤΤ٤ɤ
	if(nVExt!=nWExt){
		CSize size;
		size=sizeLog;

		if(bVert){	//ľʸκɸ
			x-=8;
			if(bPointFront) y-=size.cy;
		}else{		//ʿʸΤȤκɸ
			y-=8;
			if(!bPointFront) x-=size.cx;
		}
		size.cx=size.cx*nVExt/nWExt;
		size.cy=size.cy*nVExt/nWExt;
		x=x*nVExt/nWExt;
		y=y*nVExt/nWExt;

		if(nMode&DRAW_ON){
			CBrush* pBrush=new CBrush(col);		//꿧Υ֥饷κ
			pBrush=pDC->SelectObject(pBrush);	//֥饷
			pDC->PatBlt(x,y,size.cx,size.cy,PATCOPY);
			pBrush=pDC->SelectObject(pBrush);	//֥饷
			delete pBrush;						//֥饷κ
		}else if(nMode&DRAW_OFF){
			COLORREF colBk=pDC->GetBkColor();
			pDC->FillSolidRect(x,y,size.cx,size.cy,RGB(0,0,0));
			pDC->SetBkColor(colBk);
			//pDC->PatBlt(x,y,size.cx,size.cy,BLACKNESS);//ɤ
		}else if(nMode&DRAW_XOR){
			CBrush* pBrush=new CBrush(col);		//꿧Υ֥饷κ
			pBrush=pDC->SelectObject(pBrush);	//֥饷
			pDC->PatBlt(x,y,size.cx,size.cy,PATINVERT);
			pBrush=pDC->SelectObject(pBrush);	//֥饷
			delete pBrush;						//֥饷κ
		}else{
			TRACE("\n⡼(CBSchFont::PutFont())");
		}
	}else{
*/
	/////////////////////////////////////////////////////////////////////
	//ɽ  ʸ
		//m_pString=(char*)str;			//ʸ
		m_pString=str;				//ʸ

//		if(bVert){cx=16; 			cy=m_nStrLen*8;}
//		else     {cx=m_nStrLen*8; 	cy=9;          }

		if(bVert) 	SetToBuffV(nMode==DRAW_XORINVERT);		//ľʸΥեȥǡ
		else		SetToBuffH(nMode==DRAW_XORINVERT);		//ʿʸΥեȥǡ
		
		if(bVert){	//ľʸΤȤžɸ
			x-=15;
			if(bPointFront) y-=m_nBuffYDot-1;
		}else{		//ʿʸΤȤžɸ
			y-=8;
			if(!bPointFront) x-=m_nStrLen*8-1;
		}

//		QPixmap pmpString;
		QBitmap bmpString(m_nBuffXDot,m_nBuffYDot,m_pBmpBit,false);		//ʸΥԥޥåפκ


		DrawBitmap(pPainter,&bmpString,x,y,color,nMode);
	return;
}


//////////////////////////////////////////////////////////////////////
//Хѿ
SSmallFont g_SmallFont;		//BSchե襯饹

/*
void TEST_SmallFont(QPainter* p)
{
	static QColor aryCol[7];

	aryCol[0] = QColor("blue");
	aryCol[1] = QColor("red");
	aryCol[2] = QColor("green");
	aryCol[3] = QColor("black");
	aryCol[4] = QColor("gray");
	aryCol[5] = QColor("cyan");
	aryCol[6] = QColor("SkyBlue");

	static char szTest[]="ABCDEF";

	int i;

	szTest[1] |= 0x80;

	for(i=0;i<30;i++){
		g_SmallFont.DrawText(p,100,100+i*12,szTest,aryCol[i%7],DRAW_ON,false);
	}
}
*/



class SBmpWorkArea
{
private:
	unsigned char* bitreverse_table;
	void init_bitreverse_table();
public:
	SBmpWorkArea();
	~SBmpWorkArea();
	unsigned char* buff0;
	unsigned char* buff1;
	unsigned char bitreverse(unsigned char c) const;
};

SBmpWorkArea::SBmpWorkArea()
{
	bitreverse_table = (unsigned char*) new char[256];
	init_bitreverse_table();
	buff0 = (unsigned char*) new char[0x10000];
	buff1 = (unsigned char*) new char[0x10000];
}

SBmpWorkArea::~SBmpWorkArea()
{
	delete[]bitreverse_table;
	delete[]buff0;
	delete[]buff1;
}

void SBmpWorkArea::init_bitreverse_table()
{
	for(int n =0;n<256;n++){
		unsigned char sbit = 0x01;
		unsigned char dbit = 0x80;
		unsigned char d = 0;
		for(int i=0;i<8;i++){
			if(n & sbit) d |= dbit;
			sbit<<=1;
			dbit>>=1;
		}
		bitreverse_table[n]=d;
	}
}

unsigned char SBmpWorkArea::bitreverse(unsigned char c) const
{
	unsigned char rc = bitreverse_table[c];
	return rc;
}


//////////////////////////////////////////////////////////////////////
//Хѿ
static SBmpWorkArea bmpworkarea;


//	ӥåȥޥå 50% ̾
//  ӥåȥޥåפϥɥ饤
void g_bmp_50percent(int sx,int sy,const unsigned char *s,int& dx,int& dy,unsigned char *d)
{
	

	dx = (sx+1)/2;
	dy = (sy+1)/2;
	int sxbyte = ((sx+15)/16)*2;
	int dxbyte = ((dx+15)/16)*2;

	const unsigned char* sp;
	unsigned char* dpLineTop;
	int y;

	// Y 50% ̾  Хåեǥƥ͡Хåե˥ԡʤ
	sp			= s;
	dpLineTop	= d;
	for(y=0;y<sy;y++){
		if(y&1){	//饤϶饤 OR 롣
			for(int i=0;i<sxbyte;i++) dpLineTop[i] |= *sp++;
			dpLineTop+=sxbyte;	//ORä1饤֤ʤ
		}else{		//饤ϥԡ
			for(int i=0;i<sxbyte;i++) dpLineTop[i] = *sp++;
		}
	}
	// X 50% ̾ ǥƥ͡ХåեǺ
	int sbytecount;
	int dbytecount;
	unsigned char cc;
	sp = d;
	dpLineTop = d;
	for(y=0;y<dy;y++){
		sbytecount = 0;
		dbytecount = 0;
		unsigned char sbitm = 0xC0;
		unsigned char dbitm = 0x80;
		cc = 0;
		while(sbytecount < sxbyte){
			if(*sp & sbitm) cc |= dbitm;
			//ȥΥӥåȤʤ
			if(sbitm == 0x03){
				sbytecount++;
				sp++;
				sbitm = 0xC0;
			}else{
				sbitm >>= 2;
			}
			//̾ϤΥӥåȤʤ
			if(dbitm == 0x01){
				dpLineTop[dbytecount++] = cc;
				dbitm = 0x80;
				cc =0;
			}else{
				dbitm >>= 1;
			}
		}
		dpLineTop[dbytecount++] = cc;
		while(dbytecount < dxbyte){
			dpLineTop[dbytecount++] = 0;
		}
		dpLineTop += dxbyte;
	}
}
	

//	ӥåȥޥå 20% ̾
//  ӥåȥޥåפϥɥ饤
void g_bmp_20percent(int sx,int sy,const unsigned char *s,int& dx,int& dy,unsigned char *d)
{
	dx = (sx+4)/5;
	dy = (sy+4)/5;
	int sxbyte = ((sx+15)/16)*2;
	int dxbyte = ((dx+15)/16)*2;

	const unsigned char* sp;
	unsigned char* dpLineTop;
	unsigned char* dp;
	int y;
	int n;

	// Y 20% ̾  Хåեǥƥ͡Хåե˥ԡʤ
	sp			= s;
	dpLineTop	= d;
	n			= 0;
	for(y=0;y<sy;y++){
		dp=dpLineTop;
		if(n>0){	//n!=0 饤 n==0 饤 OR 롣
			for(int i=0;i<sxbyte;i++) dpLineTop[i] |= *sp++;
		}else{		//n==0 饤ϥԡ
			for(int i=0;i<sxbyte;i++) dpLineTop[i] = *sp++;
		}
		n++;
		if(n==5){
			dpLineTop+=sxbyte;	//5饤֤ORä1饤֤ʤ
			n=0;
		}
	}
	
	// X 20% ̾ ǥƥ͡ХåեǺ
	// 5Х1å Хåե5ХȤĥԡƽ̾롣
	unsigned char buff[5];

	int sbytecount;
	int dbytecount;
	unsigned char cc;
	sp = d;
	dpLineTop = d;
	for(y=0;y<dy;y++){
		sbytecount = 0;
		dbytecount = 0;
		while(sbytecount < sxbyte){
			//Хåե˥ԡ
			for(n=0;n<5;n++){
				if(sbytecount++ < sxbyte) buff[n]=*sp++;
				else					buff[n]=0;
			}
			cc=0;
			if( buff[0] & 0xF8)						cc |= 0x80;
			if((buff[0] & 0x07)||(buff[1] & 0xC0))	cc |= 0x40;
			if( buff[1] & 0x3E)						cc |= 0x20;
			if((buff[1] & 0x01)||(buff[2] & 0xF0))	cc |= 0x10;
			if((buff[2] & 0x0F)||(buff[3] & 0x80))	cc |= 0x08;
			if( buff[3] & 0x7C)						cc |= 0x04;
			if((buff[3] & 0x03)||(buff[4] & 0xE0))	cc |= 0x02;
			if( buff[4] & 0x1F)						cc |= 0x01;
			dpLineTop[dbytecount++]=cc;
		}
		while(dbytecount < dxbyte){
			dpLineTop[dbytecount++] = 0;
		}
		dpLineTop += dxbyte;
	}
}


//  岼ȿžȿž岼ȿžϹ®˼¹ԤǤ롣
//  90ٲžϥӥåȼΤǻ֤롣
//
//    (0) 0      (1) 90     (2) 180    (3) 270
//                                
//    ԡ     ̡     ¡     ҡ     
//  ̢Ң ¢Ԣ Ң̢ Ԣ¢
//    ¡     ҡ     ԡ     ̡     
//                                
//
//    (4) M0     (5) M90    (6) M180   (7) M270
//                                
//    ԡ     ̡     ¡     ҡ     
//  Ң̢ Ԣ¢ ̢Ң ¢Ԣ
//    ¡     ҡ     ԡ     ̡     
//                                
//
//	1  0 90ٲž
//	2  0                     岼ȿž
//	3  0 270ٲž
//	4  0                         ȿž
//	5  0 90ٲžΤ      ȿž
//	6  0                     岼    ȿž
//	7  0 90ٲžΤ  岼    ȿž


//ӥåȥޥåפ岼ȿžԡ
//ȥǥƥ͡ƱǤOK
void g_bmp_vmirror(int sx,int sy,const unsigned char *s,unsigned char *d)
{
	int xbyte=((sx+15)/16)*2;
	const unsigned char* sUpper = s;
	const unsigned char* sLower = s+xbyte*(sy-1);
	unsigned char* dUpper = d;
	unsigned char* dLower = d+xbyte*(sy-1);
	unsigned char c;
	int ymax = (sy+1)/2;
	for(int y=0;y<ymax;y++){
		for(int i=0;i<xbyte;i++){
			c			=sUpper[i];
			dUpper[i]	=sLower[i];
			dLower[i]	=c;
		}
		sUpper += xbyte;
		sLower -= xbyte;
		dUpper += xbyte;
		dLower -= xbyte;
	}
}


//ӥåȥޥåפ򺸱ȿžԡ
//ȿž̡ӥåȥޥåפϥɥ饤ȱͤˤʤ
//ȥǥƥ͡ƱǤOK
void g_bmp_hmirror(int sx,int sy,const unsigned char *s,unsigned char *d)
{
	int xbyte=((sx+15)/16)*2;
	const unsigned char* sTop = s;
	unsigned char* dTop = d;
	unsigned char c;
	int xmax = xbyte/2; 
	for(int y=0;y<sy;y++){
		int i,j;
		for(i=0,j=xbyte-1;i<xmax;i++,j--){
			c			=sTop[i];
			dTop[i]		=bmpworkarea.bitreverse(sTop[j]);
			dTop[j]		=bmpworkarea.bitreverse(c);
		}
		sTop += xbyte;
		dTop += xbyte;
	}
}

//ӥåȥޥåפ岼ȿžԡ
//ȿž̡ӥåȥޥåפϥɥ饤ȱͤˤʤ
//ȥǥƥ͡ƱǤOK
void g_bmp_vhmirror(int sx,int sy,const unsigned char *s,unsigned char *d)
{
	int xbyte=((sx+15)/16)*2;
	const unsigned char* sUpper = s;
	const unsigned char* sLower = s+xbyte*(sy-1);
	unsigned char* dUpper = d;
	unsigned char* dLower = d+xbyte*(sy-1);
	unsigned char c;
	int ymax = (sy+1)/2;
	for(int y=0;y<ymax;y++){
		int i,j;
		for(i=0,j=xbyte-1;i<xbyte;i++,j--){
			c			=sUpper[i];
			dUpper[i]	=bmpworkarea.bitreverse(sLower[j]);
			dLower[j]	=bmpworkarea.bitreverse(c);
		}
		sUpper += xbyte;
		sLower -= xbyte;
		dUpper += xbyte;
		dLower -= xbyte;
	}
}


//ӥåȥޥåפ90ٲžԡ
//򺸲ĥ󡢥ǥƥ͡Ǿ饤󤫤鲣
//                 
//                        
//                 
//                    
//
void g_bmp_rot90(int sx,int sy,const unsigned char *s,int& dx,int& dy,unsigned char *d)
{
	dy = sx;
	dx = sy;
	int sxbyte=((sx+15)/16)*2;
	int dxbyte=((dx+15)/16)*2;
	int x,y;
	unsigned char* pch=d;
	for(y=0;y<dy;y++){
		for(x=0;x<dxbyte;x++){
			*pch++=0;
		}
	}


	unsigned char bitSrc,bitDst;
	const unsigned char* pSrcTop=s + sxbyte*(sy-1);	//ΥХȤؤ
	unsigned char* pDstTop=d;						//ΥХȤؤ
	bitSrc=0x80;
	for(x=0;x<sx;x++){
		const unsigned char* pSrc=pSrcTop;
		unsigned char* pDst=pDstTop;
		*pDst=0;
		bitDst=0x80;
		for(y=0;y<sy;y++){
			if(bitDst==0x80) *pDst=0;		//
			if(*pSrc & bitSrc) *pDst |= bitDst;
			pSrc-=sxbyte;		//1˰ư
			if(bitDst==0x01){	//ǥƥ͡ϺΥӥåȤ˰ư
				bitDst=0x80;	//٤ΥХȤ˰ܤȤ
				pDst++;
//				*pDst=0;		//ܤäΥХȤ
			}else{
				bitDst>>=1;
			}
		}
		//󤬽ä
		if(bitSrc==0x01){		//٤ΥӥåȤ˰ư
			bitSrc=0x80;
			pSrcTop++;
		}else{
			bitSrc>>=1;
		}
		pDstTop+=dxbyte;		//ǥƥ͡򼡤ιԤ˰ư
	}
}



//ӥåȥޥåפ270ٲžԡ
//򺸾夫ĥ󡢥ǥƥ͡򺸲鲣
//                 
//                        
//                 
//                    
//                 
void g_bmp_rot270(int sx,int sy,const unsigned char *s,int& dx,int& dy,unsigned char *d)
{
	dy = sx;
	dx = sy;
	int sxbyte=((sx+15)/16)*2;
	int dxbyte=((dx+15)/16)*2;
	int x,y;
	unsigned char* pch=d;
	for(y=0;y<dy;y++){
		for(x=0;x<dxbyte;x++){
			*pch++=0;
		}
	}


	unsigned char bitSrc,bitDst;
	const unsigned char* pSrcTop=s;	//ΥХȤؤ
	unsigned char* pDstTop=d+dxbyte*(dy-1);//ΥХȤؤ
	bitSrc=0x80;
	for(x=0;x<sx;x++){
		const unsigned char* pSrc=pSrcTop;
		unsigned char* pDst=pDstTop;
		*pDst=0;
		bitDst=0x80;
		for(y=0;y<sy;y++){
			if(bitDst==0x80) *pDst=0;		//
			if(*pSrc & bitSrc) *pDst |= bitDst;
			pSrc+=sxbyte;		//1󲼤˰ư
			if(bitDst==0x01){	//ǥƥ͡ϱΥӥåȤ˰ư
				bitDst=0x80;	//٤ΥХȤ˰ܤȤ
				pDst++;
			}else{
				bitDst>>=1;
			}
		}
		//󤬽ä
		if(bitSrc==0x01){		//٤ΥӥåȤ˰ư
			bitSrc=0x80;
			pSrcTop++;
		}else{
			bitSrc>>=1;
		}
		pDstTop-=dxbyte;		//ǥƥ͡򼡤ιԤ˰ư
	}
}

void g_put_bmp(
		QPainter* pPainter,			//
		int x,
		int y,						//ϰ
		const unsigned char* bitmap,			//Ϥӥåȥޥå(ɥ饤 Υ)
		int w,						//ԥ
		int h,						//ԥ
		int dir,					//
		int scale,					// 1,2,5Τɤ줫
		const QColor& color,		//Ͽ
		unsigned  nMode				//⡼
		)
{
	const unsigned char* srcbmp;
	switch(scale){
	case 1:
		srcbmp = bitmap;
		break;
	case 2:
		g_bmp_50percent(w,h,bitmap,w,h,bmpworkarea.buff1);
		srcbmp = bmpworkarea.buff1;
		break;
	case 5:
		g_bmp_20percent(w,h,bitmap,w,h,bmpworkarea.buff1);
		srcbmp = bmpworkarea.buff1;
		break;
	default:
		return;
	}
	switch(dir){
	case 0:
		break;
	case 1:	// 1  0 90ٲž
		g_bmp_rot90(w,h,srcbmp,w,h,bmpworkarea.buff0);
		srcbmp = bmpworkarea.buff0;
		break;
	case 2: // 2  0 岼ȿž
		g_bmp_vhmirror(w,h,srcbmp,bmpworkarea.buff0);
		srcbmp = bmpworkarea.buff0;
		break;
	case 3: // 3  0 270ٲž
//		g_bmp_rot90(w,h,srcbmp,w,h,bmpworkarea.buff0);
//		g_bmp_vhmirror(w,h,bmpworkarea.buff0,bmpworkarea.buff0);
		g_bmp_rot270(w,h,srcbmp,w,h,bmpworkarea.buff0);
		srcbmp = bmpworkarea.buff0;
		break;
	case 4: // 4  0 򺸱ȿž
		g_bmp_hmirror(w,h,srcbmp,bmpworkarea.buff0);
		srcbmp = bmpworkarea.buff0;
		break;
	case 5: // 5  0 90ٲžΤ򺸱ȿž
		g_bmp_rot90(w,h,srcbmp,w,h,bmpworkarea.buff0);
		g_bmp_hmirror(w,h,bmpworkarea.buff0,bmpworkarea.buff0);
		srcbmp = bmpworkarea.buff0;
		break;
	case 6: // 6  0 岼ȿž
		g_bmp_vmirror(w,h,srcbmp,bmpworkarea.buff0);
		srcbmp = bmpworkarea.buff0;
		break;
	case 7: // 7  0 90ٲžΤ岼ȿž
		g_bmp_rot90(w,h,srcbmp,w,h,bmpworkarea.buff0);
		g_bmp_vmirror(w,h,bmpworkarea.buff0,bmpworkarea.buff0);
		srcbmp = bmpworkarea.buff0;
		break;
	default:
		return;
	}
	int buffPixelWidth = ((w+15)/16)*16;
	if(dir==2 || dir==4 ||dir==5){
		x += (w-buffPixelWidth);
	}

	QBitmap bmp(buffPixelWidth,h,srcbmp,false);		//ʸΥԥޥåפκ
	DrawBitmap(pPainter,&bmp,x,y,color,nMode);
	return;
}
