// Copyright (C) 2002 H.Okada(suigyodo) All rights reserved.
#ifndef XBSCHVIEW_H
#define XBSCHVIEW_H

#include <qwidget.h>
#include <qscrollview.h>
#include <qclipboard.h>
#include <qbitmap.h>
#include <qtimer.h>

//#include <qcursor.h>
#include "xbsch.h"
#include "xbschdocsch.h"
#include "xbschpattern.h"

//class SXBSchDoc;
class SXBSchObj;
class QPainter;
class QCursor;

class SXBSchLabel;
class SXBSchComment;
class SXBSchComponent;
class SXBSchTag;



//class QSize;
//class QRect;
//class QPoint;

#define MAX_SHEET_WIDTH 3000
#define MAX_SHEET_HEIGHT 2000

class SXBSchView: public QScrollView
{
    Q_OBJECT
public:

	enum MOVE_OPTION
	{
		MOVE_OPTION_COMPONENT_NAME	=1,
		MOVE_OPTION_COMPONENT_NUM	=2
	};


	SXBSchView(QWidget* parent);
	~SXBSchView();
	SXBSchDocSch* Document(){return m_pDoc;}
	
	//ɽ˴ؤ
	void RefreshView(){viewport()->update();}

	//।󡦥Ȥ˴Ϣ᥽å
	bool CanZoomIn();
	bool CanZoomOut();
	void ZoomIn(bool menucommand);
	void ZoomOut(bool menucommand);

	//Խ˴ؤ
	//ԡ
	void copy();
	//å
	void cut();
	//ڡ
	void paste();
	//
	void del();
	//UNDO
	void undo();
	//Attribute
	void attribute();
	//Rotate
	void rotate();
	//Mirror
	void mirror();
	//Invert()
	void invert();
	

	//ġ˴Ϣ᥽å
	bool setToolMode(BSCH_TOOL_MODE mode);
	BSCH_TOOL_MODE toolMode(){return m_toolmode;}

	//åɽ˴Ϣ᥽å
	void setDisplayGrid(bool display);
	bool displayGrid(){return m_bDisplayGrid;}
	//ʥåפξ֤˴Ϣ᥽å
	void setSnapGrid(bool snap);
	bool snapGrid(){return m_bSnapGrid;}

	//ȥεư
	void resize();
	//ȥ
	void SetSheetSize(const QSize& size);
	//ȥμ
	QSize SheetSize();
	
	//ե¸
	int save(const QString& fname);
	//ե뤫ɤ߹
	int load(const QString& fname);
	//᡼եν
	bool exportImage(const QString& fname);

	//Ǹ¸ΤȤѹäɤ֤
	bool isDirty(){return m_pDoc->isDirty();}
	//̥֥ȤĤǤ⤢false֤
	bool isEmpty(){return m_pDoc->isEmpty();}

	//ե졼ǡȤ˥ǥեȥեȤ
	void setDefaultFont();

	void execLabelAttributeDlg(SXBSchLabel* pobj);			//٥Υȥӥ塼ѹư
	void execTagAttributeDlg(SXBSchTag* pobj);				//Υȥӥ塼ѹư
	void execComponentAttributeDlg(SXBSchComponent* pobj);	//ʤΥȥӥ塼ѹư
	void execCommentAttributeDlg(SXBSchComment* pObj);		//ȤΥȥӥ塼ѹư

//	SXBSchView();

private:
	SXBSchDocSch* m_pDoc;			//ɥȤؤΥݥ
	int  m_viewScale;			//̾Ψ
	BSCH_TOOL_MODE m_toolmode;	//ߤġΥ⡼
	bool m_bDisplayGrid;			//åɤɽ
	bool m_bSnapGrid;				//åɤؤΥʥåפξ

	bool m_bTimer;					//ޡƯ
	bool m_bLButtonDown;			//ܥβ
	bool m_bDrawSelectFrame;		//Ȥե饰
	bool m_bDrawTempLine;			//磻䡼Хˤ褹벾ե饰
	int  m_nTempLineOrder;			//磻䡼Хˤ
									//ʿʤ1ľʤ-1̤ʤ0
	
	QPoint m_ptLastMoveAtContents;	//뤬ǸưȤviewportɸ
	QPoint m_ptLastMoveAtSheet;		//뤬ǸưȤsheetɸ
	QPoint m_ptLButtonDownAtSheet;	//ܥ󤬲줿Ȥsheetɸ
	QPoint m_ptLastMoveTempAtSheet;	//ǡǸư

	int  m_nAutoScrollX;			//ưΥ
	int  m_nAutoScrollY;			//ưΥ
	SXBSchObj* m_pCursorObj;		//դޤȤ̥֥
	int	 m_moveOption;				//ưƤΤꤹ륪ץ

	QCursor* m_pCurStd;
	QCursor* m_pCurMov;

	//QClipboard* m_pClipboard;
	//bool m_bCanPaste;

	bool m_bCompleteDrawTemp;
	QTimer m_timerTempDraw;

	QFont m_defaultfont;

protected:
	//ɸѴ˴ؤ
	QPoint ContentsToSheet(const QPoint& point);	//ContentsκɸsheetɸؤѴ
	QRect  ContentsToSheet(const QRect& rc);		//ContentsκɸsheetɸؤѴ 	
	QPoint SheetToContents(const QPoint& point);	//sheetκɸContentsɸؤѴ 	
	QRect  SheetToContents(const QRect& rc);		//sheetκɸContentsɸؤѴ 	
	QPoint snapPoint(const QPoint& point);			//ǴΥåɤΰ֤֤ 	
	//ưΥ̤
	void setAutoScrollValue();



	void JumpTo(QPoint& jumpto);//̺ɸӥ塼濴ˤ

	//̥ե졼˴Ϣ  xbschdrawobject.cpp
	void drawFrameHMarks(QPainter*p,int y,int width,const QColor& color);
	void drawFrameVMarks(QPainter*p,int x,int height,const QColor& color);
	void drawFrame(QPainter*p,const QRect& rcClip,const QColor& color);
	void drawGrid(QPainter*p,const QRect& rcClip,const QColor& color);

	//ꥹȾΥǡ xbschdrawobject.cpp
	void drawMainXBSchObj(QPainter*p,unsigned  nMode,SRect* prcClip);
	void drawTempXBSchObj(QPainter*p,unsigned  nMode,SRect* prcClip);

	
	void drawXBSchObj(QPainter*p,SXBSchObj* pObj,unsigned  nMode,SRect* prcClip);	//Ǥ  xbschdrawobject.cpp
	void drawJunction(QPainter* p,SXBSchObj* pObj,unsigned  nMode);					//󥯥
	void drawLabel(QPainter* p,SXBSchObj* pObj,unsigned  nMode);					//٥
	void drawTag(QPainter* p,SXBSchObj* pObj,unsigned  nMode);						//
	void drawLineData(QPainter* p,SXBSchObj* pObj,unsigned  nMode);					//
	void drawComponent(QPainter* p,SXBSchObj* pObj,unsigned  nMode,SRect* prcClip);	//ʤ
	void drawComment(QPainter* p,SXBSchObj* pObj,unsigned  nMode);					//Ȥ

	//ե졼  								xbschdrawobject.cpp
	void drawSelectFrame(QPainter*p);
	//ǡΥե졼  						xbschdrawobject.cpp
	void drawTempDataFrame(QPainter*p);
	//ˤĤޤȤ̥֥Ȥ 		xbschdrawobject.cpp 	
	void drawCursorObj(QPainter*p);
	//		  								xbschdrawobject.cpp
	void drawTempLine(QPainter*p);

	/////////////////////////////////////////
	//  ֤˴Ϣ
	//٥
	bool placeLabel(const QPoint&);		//٥
	bool placeTag(const QPoint&);		//
	bool placeComponent(const QPoint&);	//ʤ
	bool placeComment(const QPoint& point);	//Ȥ

signals:
	void cursorMove(int x,int y);
	void toolChange();

private slots:
	//void whenScroll(int x,int y);
	void onScrollTimer();
	void onTimerDrawTemp();
	//void clipboardChanged();

protected:
	void contentsMousePressEvent(QMouseEvent*);
	void contentsMouseReleaseEvent(QMouseEvent *);
	void contentsMouseMoveEvent(QMouseEvent *me);
	void contentsMouseDoubleClickEvent ( QMouseEvent * );
	//void viewportPaintEvent (QPaintEvent *);
	void wheelEvent( QWheelEvent * e );

	//													xbschdrawobject.cpp
	void drawContents(QPainter*p,int clipx,int clipy, int clipw, int cliph );

	void viewportResizeEvent(QResizeEvent * );
};


#endif
